/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.h
*  :	Flynn Yin
*  :	V3.01
*  :	2019/1
*  :	ͷļ
*  ע:    HR7P201/202ԺӦ
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __TKM_CONFIG_H__
#define   __TKM_CONFIG_H__

#include <hic.h>
#include "common.h"
#include "main.h"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#define  TK0        0   // PA0
#define  TK1        1   // PA1
#define  TK2        2   // PA2
#define  TK3        3   // PA3
#define  TK4        4   // PA5
#define  TK5        5   // PA6
#define  TK6        (0x80+6 )   // PB0
#define  TK7        (0x80+7 )   // PB1
#define  TK8        (0x80+8 )   // PB2
#define  TK9        (0x80+9 )   // PB3
#define  TK10       (0x80+10)   // PB4
#define  TK11       (0x80+11)   // PB5
#define  TK12       (0x80+12)   // PB6
#define  TK13       (0x80+13)   // PB7
#define  TK14       (0x40+14)   // PC0
#define  TK15       (0x40+15)   // PC1
#define  TK16       (0x40+16)   // PC2
#define  TK17       (0x40+17)   // PC3
#define  TK18       (0x40+18)   // PC4
#define  TK19       (0x40+19)   // PC5
#define  TK20       (0x20+20)   // PE0
#define  TK21       (0x20+21)   // PE1
#define  TK22       (0x20+22)   // PE2
#define  TK23       (0x20+23)   // PE3

#define  TK_Ch0   0
#define  TK_Ch1   1
#define  TK_Ch2   2
#define  TK_Ch3   3
#define  TK_Ch4   4
#define  TK_Ch5   5
#define  TK_Ch6   6
#define  TK_Ch7   7
#define  TK_Ch8   8
#define  TK_Ch9   9
#define  TK_Ch10   10
#define  TK_Ch11   11
#define  TK_Ch12   12
#define  TK_Ch13   13
#define  TK_Ch14   14
#define  TK_Ch15   15
#define  TK_Ch16   16
#define  TK_Ch17   17
#define  TK_Ch18   18
#define  TK_Ch19   19
#define  TK_Ch20   20
#define  TK_Ch21   21
#define  TK_Ch22   22
#define  TK_Ch23   23

	
#define  TK_Guardsensor_output     OFF         // 
#define  TK_Guardsensor_setting    PB0        //ɨʱ߱ɨͨȣģʽΪͨ
#define  TK_GuardIOtrise_setting   PBT0

#define  TK_Mult_inhibition     2           // 0---5  ټϵ 0   1 50% 225%  312.5% 46.25%   ڽָѹټ
#define  Max_Minvalueoff_filter     ON          // ON/ OFF ȥСֵ
#define  Jitter_level1_Threshold    600         // When more than this  value use a specilize filter  base was locked                 Type value  100*TK_NUM 
#define  Jitter_level2_Threshold    3000        // When more than this  value use a specilize filter2 Debounce  conter was cleared    Type value  500*TK_NUM 
#define  Jitter_tolerance           0           //0 --5  ݴ趨
#define  Auto_Jitter_software       ON          //Ƶ,ùʹȥȥС                                         // ûаʱԶӦ

	
#define SLAVE_ADDR  0x4E	//ӻַ
#define COMMOND4	0x50	//4ֵ
#define COMMOND0	0x51	//0ͨ
#define COMMOND1	0x5A	//1
#define COMMOND2	0x5B	//2˲
#define COMMOND3	0x5C	//3
#define COMMOND5	0x5D	//5оƬλ

extern const uchar Channel_table[];
extern const uint  Threshold_table[];
extern const uchar Channel_md2table[];
extern const uint  Threshold_md2table[];
extern const uchar Channel_MatrixRowtable[];
extern const uchar Channel_MatrixColumetable[];
extern const uchar Channel_Slidertable[];
extern const uchar Channel_Wheeltable[];
extern const uchar REG_PAT[];
extern const uchar ChannelSum;
extern const uchar ChannelSummd2;
extern const uchar DF_MCU_Type;
extern const uchar DF_TK_MODE2;
extern const uchar DF_TK_Matrix_Row_NUM;
extern const uchar DF_TK_Matrix_Column_NUM;
extern const uchar DF_TK_Slider_Levels;
extern const uchar DF_TK_Slider_poles_setting;
extern const uchar DF_TK_Wheel_Levels;
extern const uchar DF_TK_Wheel_poles_setting;
extern const uchar DF_TK_Jittersample;
extern const uchar DF_TK_Singlepress;



extern void TKInit(void);	    //TKʼ
extern void TKScan(void);		//TKɨ
extern void TKRead(void);		//TKȡֵ
extern void Config_TKIO(uchar TK_Channelx );
extern void Config_TKIO2(uchar TK_Channelx );
extern void Tk_service(void);
extern void Tk_getbaselinedata(void);
extern void Singlekeyprocess(void);
extern void Matrix_process(void);
extern void Force_average(uchar num_th);
extern void TK_IO_output(void);
extern ulong CheckSliderID(uchar *p,uchar num);
//#if TK_Slider_Function ==ON
extern void Slider_process(void);
extern void Wheel_process(void);
extern void TK_Modeswitch(void);

extern uint DataFilter(uint Origin,uint Befilter);
extern uchar Mult_inhibition(uint Dlt_data ,uchar Inhibition_data);

//#endif
//#if TK_Powersavemode_function  ==ON
extern void Sleep_thenscan(void);
//#endif
extern void Update_filterdata(uchar j,uint TK_Samplevalue_stp );
extern void Update_averagedata(uchar j,uint TK_Samplevalue_stp );
/************************************************************************************************************************************/
#endif



