/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ͷļ
*  ע:    ES7P203ԺӦ
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __TKM_CONFIG_H__
#define   __TKM_CONFIG_H__

#include <hic.h>
#include "common.h"
#include "main.h"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#define  TK_reg_TKSELL  				(TK_Channel_Sel & 0xFF)
#define  TK_reg_TKSELH  				((TK_Channel_Sel>>8) & 0xFF)

#define  TK_Guardsensor_output  		OFF          /*ܿ SNR*/

#define  Jitter_level1_Threshold    	60*TK_NUM   // When more than this  value use a specilize filter  base was locked                 Type value  100*TK_NUM 
#define  Jitter_level2_Threshold    	100*TK_NUM  // When more than this  value use a specilize filter2 Debounce  conter was cleared    Type value  500*TK_NUM 

//
#define  TK_UARToutput_function			ON			// ON/ OFF
#define  TK_UARToutput_Baudrate			9600		// 115200  57600 38400 19200 .......9600
#define  TK_UARToutput_Databit      	8			// 4,5,6,7,8
#define  TK_UARToutput_Stopbit      	1			// 1,2,3(1.5)
#define  TK_UARToutput_Verifybit    	No			// No Even Odd 

#define  TK_JITTER_DEBUG				OFF			// ȶ
#define  TK_SLEEP_DEBUG					OFF			// ˯߲
//TK_IOoutput_function  Setting       
#define  TK_IOoutput_NUM        0               // 0 1--16 ˳Ӧ TK_Channelx ״̬
//IO
#define  TK_IOoutput_port0   	PE4                // IO bit
#define  TK_IOoutput_port1   	PE3
#define  TK_IOoutput_port2   	PE2
#define  TK_IOoutput_port3   	PE5
#define  TK_IOoutput_port4   	PE0
#define  TK_IOoutput_port5   	PE1
#define  TK_IOoutput_port6   	PE7
#define  TK_IOoutput_port7   	PB3
#define  TK_IOoutput_port8   	PB2
#define  TK_IOoutput_port9   	PB1
#define  TK_IOoutput_port10  	PB4
#define  TK_IOoutput_port11  	PB5
//IO λ
#define  TK_IOoutput_trise0   	PET4               // IO  TRISE bit
#define  TK_IOoutput_trise1   	PET3
#define  TK_IOoutput_trise2  	PET2
#define  TK_IOoutput_trise3   	PET5
#define  TK_IOoutput_trise4   	PET0
#define  TK_IOoutput_trise5   	PET1
#define  TK_IOoutput_trise6   	PET7
#define  TK_IOoutput_trise7   	PBT3
#define  TK_IOoutput_trise8   	PBT2
#define  TK_IOoutput_trise9   	PBT1
#define  TK_IOoutput_trise10  	PBT4
#define  TK_IOoutput_trise11  	PBT5

#define  LED_On    				0     //  0/1 
#define  LED_Off   				1     //  0/1 

//TK_advance
 
#define  TK_reg_TKTUN			0x5C        //For TKTUN register  Ƚ˲ʱ2*Tosc  Cxŵʱ512*Tosc
#define  TK_reg_TKCTL1			0x21        //
#define  TK_reg_TKFCTL			0x90        //
#define  TK_reg_VRC1			0x02        //0x02  For VRC1  register  VREF1=1.5V Ƚͽֹ 

#define  TK0					0			// PA0
#define  TK1					1			// PA1
#define  TK2					2			// PA2
#define  TK3					3			// PA3
#define  TK4					4			// PA4
#define  TK5					5			// PA5
#define  TK6					6			// PA6
#define  TK7					7			// PA7	
#define  TK8					(0x80+8)	// PB6
#define  TK9					(0x80+9)	// PB7
#define  TK10					(0x20+10)   // PE0
#define  TK11					(0x20+11)   // PE1

#define	 SLAVE_ADDR				0x4E		//ӻַ
#define  COMMOND4				0x50		//4ֵ
#define  COMMOND0				0x51		//0ͨ
#define  COMMOND1				0x5A		//1
#define  COMMOND2				0x5B		//2˲
#define  COMMOND3				0x5C		//3
#define	 COMMOND5			0x5D		//5оƬλ

extern const uchar Channel_table[];
extern const uint  Threshold_table[];
extern const uint  Threshold_table_9_10[];
extern const uchar Channel_md2table[];
extern const uint  Threshold_md2table[];

//extern const uchar REG_PAT[];
extern const uchar ChannelSum;
extern const uchar DF_TK_Singlepress;

extern const unsigned int pow_ulong[];
extern void proc_curr_tk_value(uchar idx, uchar direct);

extern void TKInit(void);	    //TKʼ
extern void  TKScan(void);		//TKɨ
extern void  TKRead(void);		//TKȡֵ
//extern void Config_TKIO(uchar TK_Channelx );
extern void Config_TKIO2(uchar TK_Channelx );
extern void Tk_service(void);
extern void Timer_check(void);
extern void Update_TKdata(void);
extern void Singlekeyprocess(void);
extern void Force_average(uchar num_th);
extern uint DataFilter(uint Origin,uint Befilter);
extern uchar Mult_inhibition(uint Dlt_data ,uchar Inhibition_data);
extern void TK_Modeswitch(void);
//#if TK_Lowpowermode  ==ON   
extern void Sleep_thenscan(void);
extern void TKStandby(void);
extern void SleepMode(void);
extern	void WDT_Clear(void);
//#endif
void TK_IO_output(void);
/************************************************************************************************************************************/
#endif





