/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ͷļ
*  ע:    ESD-SFB-7P201
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __TKM_CONFIG_H__
#define   __TKM_CONFIG_H__

#include <hic.h>
#include "common.h"
#include "main.h"

/*  */
/**********************************************************************************************************************************/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#define  Max_Minvalueoff_filter     ON          // ON/ OFF 
#define  Auto_Jitter_software       ON          // Ƶ,ùʹȥȥС
#define  Jitter_level1_Threshold    400         // When more than this  value use a specilize filter  base was locked                 Type value  100*TK_NUM 
#define  Jitter_level2_Threshold    2000        // When more than this  value use a specilize filter2 Debounce  conter was cleared    Type value  500*TK_NUM 
#define  Jitter_tolerance           2           // 0--5   
#define  TK_Getdata_ISR				ON          // ON/OFF ʹжģʽ ʹжȼжϽռ4ջ ͻó3Ƕ  ûн϶ӺǶʹOFFռж϶ջ 
#define  TK_counter_checkdata		12          // 1---65535     ѭʱ ʹΪ 100--500uS       עѭڼ         
#define  TK_Amplifi_setting			0x000FFFFF  // TK Ŵϵ趨  1--0x0FFFFFFF
#define  Timercounter_10ms          80          // 80

#define  TK_IOoutput_function		OFF         /* ON/ OFF */
#define  TK_IOoutput_NUM			6           /*1--8*/

#define  TK_IOoutput_port0			PA6         /*PA PB PC  Any bit*/
#define  TK_IOoutput_port1			PA3
#define  TK_IOoutput_port2			PA0
#define  TK_IOoutput_port3			PB2
#define  TK_IOoutput_port4			PB4
#define  TK_IOoutput_port5			PB6

#define  TK_IOoutput_trise0			PAT6        /*PA PB PC  TRISE bit*/
#define  TK_IOoutput_trise1			PAT3
#define  TK_IOoutput_trise2			PAT0
#define  TK_IOoutput_trise3			PBT2
#define  TK_IOoutput_trise4			PBT4
#define  TK_IOoutput_trise5			PBT6

#define  TK_IOLED_Function			Indicate     /*Indicate/Toggle ɿ ǿشģʽ*/
#define  LED_On						0            /* 0/1 */
#define  LED_Off					1            /* 0/1 */

//ι滮趨
#define  TKMODE2_NUM				6           //   ذ1--TK_NUM  ģʽ  0 Disable
												//   ڵ͹ĵӦʱ ʱģʽɨһͨԽʡ
#define  TKMODE2_Channel0			TK6         //   TK0--TK13  ظ ͬ
#define  TKMODE2_Channel1			TK3
#define  TKMODE2_Channel2			TK1
#define  TKMODE2_Channel3			TK8
#define  TKMODE2_Channel4			TK10
#define  TKMODE2_Channel5			TK12

#define  TK_UARToutput_function     ON        // ON/ OFF
#define  TK_UARToutput_Baudrate     9600      // 115200  57600 38400 19200 .......9600
#define  TK_UARToutput_Databit      8         // 4,5,6,7,8
#define  TK_UARToutput_Stopbit      1         // 1,2,3(1.5)
#define  TK_UARToutput_Verifybit    No        //No Even Odd 

#define  TK_JITTER_DEBUG			OFF	      //ɢ̶
#define  TK_SLEEP_DEBUG				OFF		  //˯߲
//TK_advance
#define  TK_reg_VRC1				0x84              //For VRC1  register  ʹADCVREF 2.6VVREF1=1.4V     80  0.6v     
#define  TK_reg_ACPC4				0x11              //For ACPC4 register  ʹܱȽC4ڲVREF1
#define  TK_reg_TKTUN				0x3B              //For TKTUN register
#define  TK_reg_TKSEL				0x40              //趨Ӧͨŵռձ1:2ɨƵfosc/4

#define  TK0			0   // PA0, PA1,  PA3,  PA4,  PA5,  PA6,  PA7,  PB0,   PB1,  PB2,  PB3,  PB4,  PB5,  PB6 
#define  TK1			1   // PA1
#define  TK2			2   // PA3
#define  TK3			3   // PA4
#define  TK4			4   // PA5
#define  TK5			5   // PA6
#define  TK6			6   // PA7
#define  TK7			(0x80+7 )   // PB0
#define  TK8			(0x80+8 )   // PB1
#define  TK9			(0x80+9 )   // PB2
#define  TK10			(0x80+10)   // PB3
#define  TK11			(0x80+11)   // PB4
#define  TK12			(0x80+12)   // PB5
#define  TK13			(0x80+13)   // PB6
	
#define SLAVE_ADDR  	0x4E	//ӻַ
#define COMMOND4		0x50	//4ֵ
#define COMMOND0		0x51	//0ͨ
#define COMMOND1		0x5A	//1
#define COMMOND2		0x5B	//2˲
#define COMMOND3		0x5C	//3
#define COMMOND5		0x5D	//5оƬλ

extern const uchar Channel_table[];
extern const uint  Threshold_table[];
extern const uchar REG_PAT[];
extern const uchar ChannelSum;
extern const uchar DF_TK_Singlepress;
extern ulong pow_ulong(uchar);
extern void TKInit(void);	    //TKʼ
extern void  TKScan(void);		//TKɨ
extern void  TKRead(void);		//TKȡֵ
extern void TK_IO_output(void);
//extern void Config_TKIO(uchar TK_Channelx );
extern void Config_TKIO2(uchar TK_Channelx );
extern void Tk_service(void);
extern void Timer_check(void);
extern void Update_TKdata(void);
extern void Tk_getbaselinedata(void);
extern void Check_data(void);
extern void Tk_getbase_loop( void );
extern void Singlekeyprocess(void);
extern void Force_average(uchar num_th);
extern uint DataFilter(uint Origin,uint Befilter);
extern uchar Mult_inhibition(uint Dlt_data ,uchar Inhibition_data);
extern void TKStandby(void);
extern void SleepMode(void);
extern void Customer_wakeupfromsleepmode_init(void);
//extern void Update_filterdata(uchar j,uint TK_Samplevalue_stp );
//extern void Update_averagedata(uchar j,uint TK_Samplevalue_stp );
/************************************************************************************************************************************/
#endif


