/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	main.c
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ʾ
*  ע:    ESD-TKT-7P202
			1ذ			
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************************************/
#include "stdlib.h"
#include "main.h"
#include "string.h"
/*********************************************************
:	void main()
  :	
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void main() 
{
	MCUInit();		          // MCUʼ Customer need change
							  // Customer powerup init 	
	TKInit();	    
	Delay100ms(1);
	it_vectors_init();
	TKIF = 0;                 // ж	 
	GIE  = 1;
	//TKIE = 1;
	Timer_counter = 0;
							  // initial data and average data
	Timerinit();
	Tk_getbaselinedata();
	#if TK_UARToutput_function == ON
	UARTInit();
	#endif

	while(1)
	{
		clr_wdt();	         // 忴Ź		  
		#if TK_Lowpowermode == ON
		if(g_wakeup_flag == 0)
		{
			TKStandby();	                 // sleep run					
		}
		else
		#endif
		{
			Tk_service();
			Timer_check();                   // Check if 10ms tick
			TK_IO_output();   
		}
		//TK_state =TK_state;              //Ӧʱ򿪴ע ʹTK_state Ӧ״̬λ 32bit  Ϊ1 ɿΪ0
		//TK_state_single =TK_state_single;//Ӧʱ򿪴ע ʹTK_state_single Ӧ״̬λ 32bit  Ϊ1 ɿΪ0 һЧ
	}
}

/***********************************************************
:	void MCUInit(void) 
  :	ϵͳʼӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void MCUInit(void) 
{
    OSCWP = 0x55;
	OSCEN = 0;
	HRCEN = 1;
	//LRCEN = 0;
	while(!HRCON){} //ȴHRC״̬λ
	OSCC1 = 0x00; //HRCʱԴ16M  1:1Ƶ
	while(CHG){}
	OSCWP = 0x5A;
    SBOREN = 1;
    PES = 0;		
	PAS = 0;
	PBS = 0;
	PCS = 0;

#if TK_IOoutput_function == ON
	Led_state = 0;
	#if TK_IOoutput_NUM > 0
	TK_IOoutput_port0 = LED_Off;
	TK_IOoutput_trise0 = 0;
	#endif
	#if TK_IOoutput_NUM > 1
	TK_IOoutput_port1 = LED_Off;
	TK_IOoutput_trise1 = 0;
	#endif
	#if TK_IOoutput_NUM > 2
	TK_IOoutput_port2 = LED_Off;
	TK_IOoutput_trise2 = 0;
	#endif
	#if TK_IOoutput_NUM > 3
	TK_IOoutput_port3 = LED_Off;
	TK_IOoutput_trise3 = 0;
	#endif
	#if TK_IOoutput_NUM > 4
	TK_IOoutput_port4 = LED_Off;
	TK_IOoutput_trise4 = 0;
	#endif
	#if TK_IOoutput_NUM > 5
	TK_IOoutput_port5 = LED_Off;
	TK_IOoutput_trise5 = 0;
	#endif
	#if TK_IOoutput_NUM > 6
	TK_IOoutput_port6 = LED_Off;
	TK_IOoutput_trise6 = 0;
	#endif
	#if TK_IOoutput_NUM > 7
	TK_IOoutput_port7 = LED_Off;
	TK_IOoutput_trise7 = 0;
	#endif
	#if TK_IOoutput_NUM > 8
	TK_IOoutput_port8 = LED_Off;
	TK_IOoutput_trise8 = 0;
	#endif
	#if TK_IOoutput_NUM > 9
	TK_IOoutput_port9 = LED_Off;
	TK_IOoutput_trise9 = 0;
	#endif
	#if TK_IOoutput_NUM > 10
	TK_IOoutput_port10 = LED_Off;
	TK_IOoutput_trise10 = 0;
	#endif
	#if TK_IOoutput_NUM > 11
	TK_IOoutput_port11 = LED_Off;
	TK_IOoutput_trise11 = 0;
	#endif
	#if TK_IOoutput_NUM > 12
	TK_IOoutput_port12 = LED_Off;
	TK_IOoutput_trise12 = 0;
	#endif
	#if TK_IOoutput_NUM > 13
	TK_IOoutput_port13 = LED_Off;
	TK_IOoutput_trise13 = 0;
	#endif
	#if TK_IOoutput_NUM > 14
	TK_IOoutput_port14 = LED_Off;
	TK_IOoutput_trise14 = 0;
	#endif
	#if TK_IOoutput_NUM > 15
	TK_IOoutput_port15 = LED_Off;
	TK_IOoutput_trise15 = 0;
	#endif
#endif

#if TK_Lowpowermode == ON		//͹ģʽʼ
	g_wakeup_flag = 1;
#if TK_UARToutput_function == ON
	uart_send_flag = 0;
#endif
	//g_Md2Init = 1;
	TK_mode1_nopresstimer = 0;
	memset(TK_md2value_origin,0,2*TKMODE2_NUM);
	memset(TK_md2average_backup,0,2*TKMODE2_NUM);
#endif
}

/*********************************************************
:	void Delay100ms(uint time)
  :	ʱӳ
ֵ: timeʱλ100ms
ֵ: 
ֵ:  
**********************************************************/
void Delay100ms(uchar time)
{
	uchar i, j, k;
	for(i = 0; i < time; i++)
	{
		for(j = 0; j < 100; j++)			
		{
			for(k = 0; k < 249; k++)
			{
				nop();
				nop();
				//nop();
				clr_wdt();
			}
		}
	}
}


/*********************************************************
void UARTInit(void)
  :	UARTʼӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
#if TK_UARToutput_function == ON
void UARTInit(void)
{
	PCT3 = 0;	//UART_TXΪ	
	PCT2 = 1;	//UART_RXΪ
	PCPU2 = 1;

	#if TK_UARToutput_Databit == 8
	TX2LEN	= 0;	//8λݸʽ
	RX2LEN  = 0;
	#elif TK_UARToutput_Databit == 9
	TX2LEN	= 1;	//9λݸʽ
	RX2LEN  = 1;
	#endif
	BRGH2 = 1;	//ģʽ
	#if TK_UARToutput_Baudrate == 115200
	BR2R = 8;	//115200bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 57600
	BR2R = 16;	//57600bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 38400
	BR2R = 25;	//38400bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 19200
	BR2R = 51;	//19200bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 9600
	BR2R = 103;	//9600bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 4800
	BR2R = 207;	//4800bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#endif
	RX2EN = 1;	//UARTʹ	
	RX2IE = 1;	//ʹUARTж

	TX2EN = 1;	//UARTʹ	
	TX2IE = 0;	//ֹUARTжϣҪʱʹ

	RX2IF = 0;
	TX2IF = 0;
	g_tp = 0;
    ChannelMask = 0xFFFFFFFF;
}
#endif
/*********************************************************
void Customer_Keystatejustpress(void)
  : ͨոռ⵽״̬
ֵ: 
ֵ: TK_state
ֵ:  
**********************************************************/
void Customer_Keystatejustpress(void)
{ //TK_state was just freshed  you can use the  parameter as you want
 
}

/*********************************************************
void Customer_Keystatejustrelease(void)
  : ͨոռ⵽ͷ
ֵ: 
ֵ: TK_state
ֵ:  
**********************************************************/
void Customer_Keystatejustrelease(void)
{ //TK_state was just freshed  you can use the  parameter as you want
 
}

