/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	main.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ʾ
*  ע:    ESD-TKT-7P202
			1ذ			
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************************************/
#ifndef   __MAIN_H__
#define   __MAIN_H__

#include <hic.h>
#include "common.h"
#include "tkm_config.h"

/*  */
void MCUInit(void);		//MCUʼ
void RAMClear(void);	//RAM
void Delay100ms( uchar time);	//ʱ100ms
extern void Timerinit(void);
extern void UARTInit(void);
extern void Customer_Keystatejustpress(void);
extern void Customer_Keystatejustrelease(void);

extern uint Opr_state;
extern uint TK_value;
extern uchar TK_value_get;         
extern uint Timer_counter;
extern uchar Tkchnum;
extern uchar Tkscan_numth;
extern uchar Tkscan_sampcounter;
extern void it_vectors_init(void);
extern uchar  Timer_10ms;
extern uchar TK_Jitter_tolerance[]; 

extern ulong Led_state;

typedef struct 
{
	uint tk_value_origin;     // Origin      data
	uint tk_value_filter;     // Filter data
	uint tk_value_average;    // Base line   data
	uint tk_timeout_counter;  // For TK press time counter
	uchar tk_press_table;     // For press    counter
	uchar tk_release_table;   // For release  counter
	uint tk_D_value;          // Base line   data - Filter data

  //#if  Max_Minvalueoff_filter ==ON  
    uint tk_value_max;     // Origin Max     data
    uint tk_value_min;     // Origin Min     data
  //#endif

} TKValueStru;

extern TKValueStru TK_Value_Arr[];

extern uchar Lock_averageconter;
extern uchar TK_press_counter;
extern uchar TK_release_counter;
extern ulong TK_state;
extern ulong TK_state_single;
extern uint  TK_Base_percounter;
extern uint  TK_jitter_Value;
extern uint  TK_pressing_value;

#if TK_Lowpowermode == ON
extern uint TK_mode1_nopresstimer;
extern uchar g_wakeup_flag;	//ʹܱ־
extern uint TK_md2value_origin[];     // Origin      data
extern uint TK_md2average_backup[];
#if TK_UARToutput_function == ON
extern uchar uart_send_flag;
#endif
#endif

#if (TK_UARToutput_function ==ON)||(TK_IICoutput_function ==ON)

extern uchar Cnt_Mask;
extern ulong ChannelMask;
extern uchar g_com;				    //
extern uchar g_length;				//ݳ
extern uchar g_rp;					//ָ
extern uchar g_tp;					//ָ
extern uchar g_checksum;			//У
extern uchar Tx_timer;
extern uchar UploadSampByte[(TK_NUM*2)+5];	//ֽ
extern uchar UploadRawByte[(TK_NUM*2)+5];	//˲ֽ
extern uchar UploadBaseByte[(TK_NUM*2)+5];	//ֽ
extern uchar UploadBuf[(TK_NUM*2)+5];	    //ͻ

#endif

#endif

/********************************************************************************************************************/


