/*********************************************************
*Copyright (C), 2020, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	main.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/09
*  :	ʾͷļ
*  ע:    ESD-TKT-7P2131-Button 
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __MAIN_H__
#define   __MAIN_H__

#include <hic.h>
#include "stdlib.h"
#include "string.h"
#include "common.h"
#include "tkm_config.h"

#define	 WDT_Close		0
#define  WDT_8ms		0x18
#define  WDT_64ms		0x19
#define  WDT_128ms		0x1A
#define  WDT_256ms		0x1B
#define  WDT_512ms		0x1C
#define  WDT_1024ms		0x1D
#define  WDT_2048ms		0x1E
#define  WDT_4080ms		0x1F

extern uint Opr_state;
extern uchar g_wakeup_flag;//ʹܱ־
extern uchar Timer_counter;
extern uchar Timer_10ms;
extern uchar Timer20_Cnt;

#if TK_UARToutput_function == ON

extern uchar Cnt_Mask;
extern uchar g_com;				//
extern uchar g_length;				//ݳ
extern uchar g_rp;					//ָ
extern uchar g_tp;					//ָ
extern uchar g_checksum;			//У
extern uchar Tx_timer;
extern uchar UploadSampByte[(TK_NUM*2) + 5];		//ֽ
//extern uchar UploadRawByte[(TK_NUM*2)+5];		//˲ֽ
//extern uchar UploadBaseByte[(TK_NUM*2)+5];		//ֽ
extern uchar UploadBuf[(TK_NUM*2) + 5];	        //ͻ

void UART_init(void);

#endif

extern void proc_curr_tk_value(uchar idx, uchar direct);
extern void Delay100ms(uchar time);
extern void RAM_clear(void);
extern void WDT_set(uchar time);
extern void SysClk_set(void);
extern void Int_vectors_init(void);
extern void GPIO_set(void);
extern void MCU_init(void);
extern void Timer_T10_init(void);
extern void Customer_Keystatejustpress(void);
extern void Customer_Keystatejustrelease(void);
extern void Customer_prepareforsleepmode_init(void);
extern void Customer_wakeupfromsleepmode_init(void);

#endif
