/*********************************************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	main.c
*  :	Flynn Yin
*  :	V3.01
*  :	2019/1
*  :	ʾ
*  ע:    HRD-SWB-7P201
			1ذ󴥿ذ
			2ഥĿ
			3ഥĿ
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************************************/
#ifndef   __MAIN_H__
#define   __MAIN_H__

#include <hic.h>
#include "common.h"
#include "tkm_config.h"

/*  */
void MCUInit(void);		//MCUʼ
void RAMClear(void);	//RAM
void Delay100ms(uint time);	//ʱ100ms
extern void Timerinit(void);
extern void UARTInit(void);

extern void Customer_powerup_init(void);
extern void Customer_Tkdataready(void);
extern void Customer_IntoSleepmode_init(void);
extern void AfterSleepcmd_init(void);
extern void BeforeSleepcmd_init(void);
extern void Customer_wakeupfromsleepmode_init(void);
extern void Customer_IntoSleepmode_init(void);
extern void Customer_OutoffSleepmode_init(void);
extern void Customer_wakeupfromsleepmode_init(void);
extern void Customer_Keystatejustpress(void);
extern void Customer_Keystatejustrelease(void);
extern void Customer_Slidervalue_justrefreshed(void);
extern void Customer_Wheelvalue_justrefreshed(void);
extern void Customer_Matrixvalue_justrefreshed(void);
extern void Customer_TKchannelreuse_init(void);

extern uint Opr_state;
extern uint TK_value;
extern uint Timer_counter;
extern uchar T8n_back;
extern uchar Tkchnum;
extern uchar Tkscan_numth;
extern uchar Tkscan_sampcounter;
extern uint  TK_jitter_Value;
extern uint TK_value_origin[];     // Origin      data
extern uint TK_value_filter[];     // Filter data
extern uint TK_value_average[];    // Base line   data
extern uint TK_timeout_counter[];  // 
extern uint TK_average_backup[];
extern uint TK_md2average_backup[];
extern uint TK_value_origin_max[];
extern uint TK_value_origin_min[];
extern uchar TK_press_table[];     // TkPress counter
extern uchar TK_release_table[];   // TkRelease counter


//#if  TK_Singlepress ==ON  
extern uint TK_D_value[];         // D value  data to see if which one is the most one
//#endif

//#if  TK_Matrix_Function ==ON  
extern uint TK_D_Rvalue[];             // D value  data to see if which one is the most one
extern uint TK_D_Cvalue[];             // D value  data to see if which one is the most one
extern ulong TK_Matrix_RID;
extern ulong TK_Matrix_CID;
extern uint  TK_Matrix_value;
extern uchar Matrix_timer;                                  // Time to clear
//#endif

//#if  TK_Slider_Function ==ON  
extern int TK_D_slider[];         // D value  data to see if which one is the most one
extern ulong TK_slider_ID;
extern uint  TK_slider_value;
extern uchar Slider_timer;                             // Time to clear
//#endif


//#if  TK_Wheel_Function ==ON  
extern int  TK_D_wheel[];                                     // D value  data to see if which one is the most one
extern ulong TK_wheel_ID;
extern uint  TK_wheel_value;
extern uchar Wheel_timer;                                     // Time to clear
//#endif

//#if    TK_Powersavemode_function  ==ON
extern uint TK_mode1_nopresstimer;
//#endif

extern uchar Lock_averageconter;
extern uchar TK_press_counter;
extern uchar TK_release_counter;
extern ulong TK_state;
extern ulong TK_state_backup;
extern ulong TK_state_single;
extern uint  TK_Base_percounter;
extern ulong Led_state;
extern uint  TK_Jitter_delay;
extern uchar TK_Jitter_timer;
extern uchar TK_modeth;
extern uchar Powersave_switching;
extern uint  TK_pressing_value;

//#if (TK_UARToutput_function ==ON)||(TK_IICoutput_function ==ON)

extern uchar g_com;				    //
extern uchar g_length;				//ݳ
extern uchar g_rp;					//ָ
extern uchar g_tp;					//ָ
extern uchar g_checksum;			//У
extern uchar Tx_timer;
extern uchar UploadSampByte[(TK_NUM*2)+5];	//ֽ
extern uchar UploadRawByte[(TK_NUM*2)+5];	//˲ֽ
extern uchar UploadBaseByte[(TK_NUM*2)+5];	//ֽ
extern uchar UploadBuf[(TK_NUM*2)+5];	    //ͻ

//#endif


#endif

/********************************************************************************************************************/

