/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ͷļ
*  ע:    ES7P202ԺӦ
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __TKM_CONFIG_H__
#define   __TKM_CONFIG_H__

#include <hic.h>
#include "common.h"
#include "main.h"

/*  */
/**********************************************************************************************************************************/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#define  Max_Minvalueoff_filter     ON          // ON/ OFF ȥСֵ
#define  Auto_Jitter_software       ON          // Ƶ,ùʹȥȥС
#define  Jitter_level1_Threshold    600         // When more than this  value use a specilize filter  base was locked                 Type value  100*TK_NUM 
#define  Jitter_level2_Threshold    3000        // When more than this  value use a specilize filter2 Debounce  conter was cleared    Type value  500*TK_NUM 
#define  Jitter_tolerance           0           // 0 --5  ݴ趨
#define  TK_Amplifi_setting			0x000FFFFF  // TK Ŵϵ趨  1--0x0FFFFFFF
#define  Timercounter_10ms          80          // ʱ10MS 80 

#define  TK_IOoutput_function		OFF         /* ON/ OFF */
#define  TK_IOoutput_NUM			6			/*1--16*/

#define  TK_IOoutput_port0			PB2			/*PA PB PC  Any bit*/
#define  TK_IOoutput_port1			PB5
#define  TK_IOoutput_port2			PC7
#define  TK_IOoutput_port3			PC1
#define  TK_IOoutput_port4			PE0
#define  TK_IOoutput_port5			PE3

#define  TK_IOoutput_trise0			PBT2        /*PA PB PC  TRISE bit*/
#define  TK_IOoutput_trise1			PBT5
#define  TK_IOoutput_trise2			PCT7
#define  TK_IOoutput_trise3			PCT1
#define  TK_IOoutput_trise4			PET0
#define  TK_IOoutput_trise5			PET3

#define  TK_IOLED_Function			Indicate    /*Indicate/Toggle ɿ ǿشģʽ*/
#define  LED_On						0			/* 0/1 */
#define  LED_Off					1			/* 0/1 */
//͹ģʽ趨	
#define  TKMODE2_NUM				6			//   ذ1--TK_NUM  ģʽ  0 Disable
												//   ڵ͹ĵӦʱ ʱģʽɨһͨԽʡ
#define  TKMODE2_Channel0			TK_Channel0
#define  TKMODE2_Channel1			TK_Channel1
#define  TKMODE2_Channel2			TK_Channel2
#define  TKMODE2_Channel3			TK_Channel3
#define  TKMODE2_Channel4			TK_Channel4
#define  TKMODE2_Channel5			TK_Channel5
#define  TKMODE2_Channel6			TK_Channel6

#define  TK_UARToutput_function     ON          // ON/ OFF
#define  TK_UARToutput_Baudrate     9600     	// 115200  57600 38400 19200 .......9600
#define  TK_UARToutput_Databit      8           // 4,5,6,7,8
#define  TK_UARToutput_Stopbit      1           // 1,2,3(1.5)
#define  TK_UARToutput_Verifybit    No          //No Even Odd 

#define  TK_JITTER_DEBUG			OFF		//ɢ̶
#define  TK_SLEEP_DEBUG				OFF		//˯߲
//TK_advance
#define  TK_reg_VRC1				0x02              //For VRC1  register  ʹADCVREF 2.6VVREF1=1.5V     80  0.6v     
#define  TK_reg_ACPC4				0x11              //For ACPC4 register  ʹܱȽC4ڲVREF1
#define  TK_reg_TKTUN				0x10              //For TKTUN register
#define  TK_reg_TKSEL				0x80              //趨Ӧͨŵռձ1:2ɨƵfosc/4

#define  TK0				0   // PA0
#define  TK1				1   // PA1
#define  TK2				2   // PA2
#define  TK3				3   // PA3
#define  TK4				4   // PA5
#define  TK5				5   // PA6
#define  TK6				(0x80+6 )   // PB0
#define  TK7				(0x80+7 )   // PB1
#define  TK8				(0x80+8 )   // PB2
#define  TK9				(0x80+9 )   // PB3
#define  TK10				(0x80+10)   // PB4
#define  TK11				(0x80+11)   // PB5
#define  TK12				(0x80+12)   // PB6
#define  TK13				(0x80+13)   // PB7
#define  TK14				(0x40+14)   // PC0
#define  TK15				(0x40+15)   // PC1
#define  TK16				(0x40+16)   // PC2
#define  TK17				(0x40+17)   // PC3
#define  TK18				(0x40+18)   // PC4
#define  TK19				(0x40+19)   // PC5
#define  TK20				(0x20+20)   // PE0
#define  TK21				(0x20+21)   // PE1
#define  TK22				(0x20+22)   // PE2
#define  TK23				(0x20+23)   // PE3
	
#define SLAVE_ADDR			0x4E	//ӻַ
#define COMMOND4			0x50	//4ֵ
#define COMMOND0			0x51	//0ͨ
#define COMMOND1			0x5A	//1
#define COMMOND2			0x5B	//2˲
#define COMMOND3			0x5C	//3
#define COMMOND5			0x5D	//5оƬλ

extern const uchar Channel_table[];
extern const uint  Threshold_table[];
extern const uchar REG_PAT[];
extern const uchar ChannelSum;

extern const uchar DF_TK_Singlepress;

extern ulong pow_ulong(uchar);
extern void TKInit(void);	    //TKʼ
extern void  TKScan(void);		//TKɨ
extern void  TKRead(void);		//TKȡֵ
extern void TK_IO_output(void);
//extern void Config_TKIO(uchar TK_Channelx );
extern void Config_TKIO2(uchar TK_Channelx );
extern void Tk_service(void);
extern void Timer_check(void);
extern void Update_TKdata(void);
extern void Tk_getbaselinedata(void);
extern void Singlekeyprocess(void);
extern void Force_average(uchar num_th);
extern uint DataFilter(uint Origin,uint Befilter);
extern uchar Mult_inhibition(uint Dlt_data ,uchar Inhibition_data);
//extern void Update_filterdata(uchar j,uint TK_Samplevalue_stp );
//extern void Update_averagedata(uchar j,uint TK_Samplevalue_stp );
extern void TKStandby(void);
extern void Customer_wakeupfromsleepmode_init(void);
/************************************************************************************************************************************/
#endif


