/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.c
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ó
*  ע:    ESD-TKT-7P202
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "common.h"
#include "stdlib.h"
#include "string.h"
#include "main.h"
#include "tkm_config.h"

ulong pow_ulong(uchar i)
{
	return ((ulong)1<<i);
}

const uchar Channel_table[TK_NUM]=     // Channel table for use as tk channel
{
 #if TK_NUM >0
 TK_Channel0
 #endif
 #if TK_NUM >1
 ,TK_Channel1
 #endif
 #if TK_NUM >2
 ,TK_Channel2
 #endif
 #if TK_NUM >3
 ,TK_Channel3
 #endif
 #if TK_NUM >4
 ,TK_Channel4
 #endif
 #if TK_NUM >5
 ,TK_Channel5
 #endif
 #if TK_NUM >6
 ,TK_Channel6
 #endif
 #if TK_NUM >7
 ,TK_Channel7
 #endif
 #if TK_NUM >8
 ,TK_Channel8
 #endif
 #if TK_NUM >9
 ,TK_Channel9
 #endif
 #if TK_NUM >10
 ,TK_Channel10
 #endif
 #if TK_NUM >11
 ,TK_Channel11
 #endif
 #if TK_NUM >12
 ,TK_Channel12
 #endif
 #if TK_NUM >13
 ,TK_Channel13
 #endif
 #if TK_NUM >14
 ,TK_Channel14
 #endif
 #if TK_NUM >15
 ,TK_Channel15
 #endif
#if TK_NUM >16
 ,TK_Channel16
 #endif
#if TK_NUM >17
 ,TK_Channel17
 #endif
#if TK_NUM >18
 ,TK_Channel18
 #endif
#if TK_NUM >19
 ,TK_Channel19
 #endif
#if TK_NUM >20
 ,TK_Channel20
 #endif
#if TK_NUM >21
 ,TK_Channel21
 #endif
#if TK_NUM >22
 ,TK_Channel22
 #endif
#if TK_NUM >23
 ,TK_Channel23
 #endif

};

const uint Threshold_table[TK_NUM]=    // Threshold table for tk channel
{
 #if TK_NUM >0
 TK_Threshold_Channel0
 #endif
 #if TK_NUM >1
 ,TK_Threshold_Channel1
 #endif
 #if TK_NUM >2
 ,TK_Threshold_Channel2
 #endif
 #if TK_NUM >3
 ,TK_Threshold_Channel3
 #endif
 #if TK_NUM >4
 ,TK_Threshold_Channel4
 #endif
 #if TK_NUM >5
 ,TK_Threshold_Channel5
 #endif
 #if TK_NUM >6
 ,TK_Threshold_Channel6
 #endif
 #if TK_NUM >7
 ,TK_Threshold_Channel7
 #endif
 #if TK_NUM >8
 ,TK_Threshold_Channel8
 #endif
 #if TK_NUM >9
 ,TK_Threshold_Channel9
 #endif
 #if TK_NUM >10
 ,TK_Threshold_Channel10
 #endif
 #if TK_NUM >11
 ,TK_Threshold_Channel11
 #endif
 #if TK_NUM >12
 ,TK_Threshold_Channel12
 #endif
 #if TK_NUM >13
 ,TK_Threshold_Channel13
 #endif
 #if TK_NUM >14
 ,TK_Threshold_Channel14
 #endif
#if TK_NUM >15
 ,TK_Threshold_Channel15
 #endif
#if TK_NUM >16
 ,TK_Threshold_Channel16
 #endif
#if TK_NUM >17
 ,TK_Threshold_Channel17
 #endif
#if TK_NUM >18
 ,TK_Threshold_Channel18
 #endif
#if TK_NUM >19
 ,TK_Threshold_Channel19
 #endif
#if TK_NUM >20
 ,TK_Threshold_Channel20
 #endif
#if TK_NUM >21
 ,TK_Threshold_Channel21
 #endif
#if TK_NUM >22
 ,TK_Threshold_Channel22
 #endif
#if TK_NUM >23
 ,TK_Threshold_Channel23
 #endif
};

#if TK_Lowpowermode == ON		//͹ģʽʼ
#if    TKMODE2_NUM ==1
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0};
#elif  TKMODE2_NUM ==2
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1};
#elif  TKMODE2_NUM ==3
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2};
#elif  TKMODE2_NUM ==4
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3};
#elif  TKMODE2_NUM ==5
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4};
#elif  TKMODE2_NUM ==6
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5};
#elif  TKMODE2_NUM ==7
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6};
#elif  TKMODE2_NUM ==8
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7};
#elif  TKMODE2_NUM ==9
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8};
#elif  TKMODE2_NUM ==10
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9};
#elif  TKMODE2_NUM ==11
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10};
#elif  TKMODE2_NUM ==12
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11};
#elif  TKMODE2_NUM ==13
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12};
#elif  TKMODE2_NUM ==14
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13};
#elif  TKMODE2_NUM ==15
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14};
#elif  TKMODE2_NUM ==16
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15};
#elif  TKMODE2_NUM ==17
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16};
#elif  TKMODE2_NUM ==18
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17};
#elif  TKMODE2_NUM ==19
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18};
#elif  TKMODE2_NUM ==20
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19};
#elif  TKMODE2_NUM ==21
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20};
#elif  TKMODE2_NUM ==22
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21};
#elif  TKMODE2_NUM ==23
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21,TKMODE2_Channel22};
#elif  TKMODE2_NUM ==24
	const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21,TKMODE2_Channel22,TKMODE2_Channel23};
#endif 
#endif

#if (TK_UARToutput_function == ON)||(TK_IICoutput_function == ON)
uchar Cnt_Mask;
ulong ChannelMask;
uchar g_com;				//
uchar g_length;				//ݳ
uchar g_rp;					//ָ
uchar g_tp;					//ָ
uchar g_checksum;			//У
uchar Tx_timer;
uchar UploadSampByte[(TK_NUM*2)+5];	//ֽ
uchar UploadRawByte[(TK_NUM*2)+5];		//˲ֽ
uchar UploadBaseByte[(TK_NUM*2)+5];	//ֽ
uchar UploadBuf[(TK_NUM*2)+5];	        //ͻ

#endif

const uchar ChannelSum    = TK_NUM;	        //ʵʰֵ tkm_config.h޸
const uchar DF_TK_Singlepress   =TK_Singlepress;
uint  Opr_state;
/*
Bit15  Scan Enable bit   1 on 0 off
Bit14  Tempdata is full  1 full 0 receive
Bit13  Jillter sample enable bit  1 Enable     0  Disable
Bit12  Once scan complete bit     1 complete   0  busy
Bit11  Slider bit    1 Slider was be touch 0 not be touch
Bit10  Wheel  bit    1 Wheel  was be touch 0 not be touch
Bit9   Matrix Row bit     1   was be touch 0 not be touch
Bit8   Matrix Column bit  1   was be touch 0 not be touch
Bit7   Mode bit  0  Mode default  1  Mode2  
Bit6   Mode switch start switching  if 1 else 0       
Bit5   Powersave flag setting if 1 else 0
Bit4
Bit3
Bit2
Bit1
Bit0
*/
#if TK_Lowpowermode == ON
uint TK_md2value_origin[TKMODE2_NUM];     // md2 Origin  data
uint TK_md2average_backup[TKMODE2_NUM];//  ={0};//md2 average data
uchar md2Tkscan_numth;         //The active numth
uint TK_mode1_nopresstimer;
uchar g_wakeup_flag;	//ʹܱ־
#if TK_UARToutput_function == ON
uchar uart_send_flag;
#endif
#endif
uint  TK_value;             //Temp value after scan
uchar TK_value_get;         //Temp value flag after scan
uint  Timer_counter;        //Timer counter        
uchar Tkchnum;              //TK num
uchar Tkscan_numth;         //The active numth
uchar Tkscan_sampcounter;   //Sample counter  1--TK_Samples_perscan

TKValueStru TK_Value_Arr[TK_NUM];
uint  TK_jitter_Value;
uchar Lock_averageconter;
uchar TK_press_counter;
uchar TK_release_counter;
ulong TK_state;
ulong TK_state_single;
uint  TK_Base_percounter;
uint  TK_pressing_value;
uchar Timer_10ms;
uchar TK_Jitter_tolerance[TK_NUM]; 
/*********************************************************
:	void TKInit(void)
  :	ʼӳ
ֵ: 
**********************************************************/
void TKInit(void )
{
	uchar i;
	PAT |= 0x80;		// PA7 Must be Setinput
	VRC = TK_reg_VRC1;	//ʹADCVREF 2.6VVREF1=1.4V
 
	TKMODL = (uchar)TK_Amplifi_setting;//÷ŴϵĴ24λ
	TKMODM = (uchar)(TK_Amplifi_setting>>8);
	TKMODH = (uchar)(TK_Amplifi_setting>>16);
	TKMODU = (uchar)(TK_Amplifi_setting>>24);//Ŵϵ4λ=0

	//TKEN = 1;			    //ʹܴλ
	TKTUN = TK_reg_TKTUN;	//1ΣȽ˲ʱ8*ToscCxŵʱ32*ToscTKδΪ͵ƽ	
	Tkchnum = TK_NUM;
	Tkscan_numth = 0;
	Tkscan_sampcounter = 0;
	Opr_state = 0x8000;     //Enable scan
 
	TKSEL = 0x80;           // 趨Ӧͨŵռձ1:2ɨƵfosc/4
	TK_state = 0;
	TK_Base_percounter = 0;

	TKValueStru * ptr = &TK_Value_Arr;
	i = 0;
	for(; ptr < TK_Value_Arr + TK_NUM; ptr++)  //Clear all 
	{
		memset(ptr, 0, sizeof(TKValueStru));
		TK_Jitter_tolerance[i] = 0; 
		i++;
	}  
	TK_value_get = 0;
	Timer_10ms = 0;
	Lock_averageconter = 0;
}

#if TK_Lowpowermode == ON
/*********************************************************
:	void SleepMode(void)
  :	˯ģʽŹڻ
ֵ: 
ֵ: 
ֵ: 
**********************************************************/
void SleepMode(void)
{
//رʹģ鼰жʹ
	GIE = 0;        //رжʹ
	TX2EN = 0;		//رUART-TX2
	TX2IE = 0;
	RX2EN = 0;		//رUART-RX2 
	RX2IE = 0;	
	T10EN = 0;		//رT10	
	T10IE = 0;
	TKEN = 0;		//رTK
	TKIE = 0;
//ùܽŷ״̬ƽ  
	PAT = 0x00;		//̶
	PBT = 0x00;		
	PCT = 0x00;
	PET = 0x00;

	PA = 0x80;
	PB = 0x24;
	PC = 0x82;
	PE = 0x09;
//رϵͳģʱ		
	//CLKG0 = 0;		//ADCCE  T21CE  T20CE  -     T13CE    T12CE     T11CE     T10CE
	//CLKG1 = 0;		// -      -     TKCE  IICCE  UART3CE  UART2CE   UART1CE   UART0CE
	OSCWP = 0x55;
	OSCEN = 0;		//رʱ
	HRCEN = 0;
	//LRCEN = 0;
//ŹʱʱѼӰ
	OSCWP = 0x5A;
	WDTUL = 0xA5;
	WDTC = 0x1B;	//ŹʱӣԤƵ1:3232*8ms=256ms @32K
	//if( TK_Wdttimer_sleepsetting >=2048 ){ WDTUL=0xA5; WDTC=0x0F;}
	//else if( TK_Wdttimer_sleepsetting >=2048 ){ WDTUL=0xA5; WDTC =0x1E;}
	//else if( TK_Wdttimer_sleepsetting >=1024 ){ WDTUL=0xA5; WDTC =0x1D;}
	//else if( TK_Wdttimer_sleepsetting >=512 ) { WDTUL=0xA5; WDTC =0x1C;}
	//else if( TK_Wdttimer_sleepsetting >=256 ) { WDTUL=0xA5; WDTC =0x1B;}
	//else if( TK_Wdttimer_sleepsetting >=128 ) { WDTUL=0xA5; WDTC =0x1A;}
	//else if( TK_Wdttimer_sleepsetting >=64 )  { WDTUL=0xA5; WDTC =0x19;}
	//else if( TK_Wdttimer_sleepsetting >=8 )   { WDTUL=0xA5; WDTC =0x18;}

	sleep();		//sleep

//Ѻִмɨ
	WDTUL = 0xA5;	
	WDTC = 0x00;	//رտŹʱӣԤƵ1:3232*8ms=256ms @32K
	
	OSCWP = 0x55;
	OSCEN = 0;
	HRCEN = 1;
	LRCEN = 0;
	while(!HRCON){} //ȴHRC״̬λ
	OSCC1 = 0x00; //HRCʱԴ16M  1:1Ƶ
	//while(CHG){}
	OSCWP = 0x5A;
	
	//CLKG0 = 0xFF;   //ADCCE  T21CE  T20CE  -     T13CE    T12CE     T11CE     T10CE
	//CLKG1 = 0x3F;   // -      -     TKCE  IICCE  UART3CE  UART2CE   UART1CE   UART0CE
	//TKCE = 1;
	//T10CE = 1;		//T10ģʱ
	//TKEN = 1;
	TKCE = 1;
	TKEN = 1;
}

/*********************************************************
:	void TKStandby(void)
  :	TK˯ɨӳ
ֵ: 
ֵ: 
ֵ: 
**********************************************************/
uint TK_Sleep_Cnt;
void TKStandby(void)
{
	//uint cmp1, cmp2;
	uchar i,j;
	clr_wdt();
	
	SleepMode();
	TK_Sleep_Cnt++;
	////PAT7 = 1;
	TKCTL = 0x03;		//ʹܴʹģ飬TKGO=1ɨ
	while(!TKIF)
	{
		TKCTL = 0x03;	//ʹܴʹģ飬TKGO=1ɨ
	}	
					
	TKGO = 0;			//Ӧģر
	PAT7 = 0;	
	PA7 = 0;			//Cxŵ
	TKIF = 0;
	if(TK_Sleep_Cnt < 250)
	{
		for(i = 0; i < 4; i++)
		{
			if(md2Tkscan_numth >= TKMODE2_NUM)		//ɨͨ±꣺0~11
			{
#if TK_SLEEP_DEBUG == ON
				for(j = 0; j < TKMODE2_NUM; j++)
				{
					UploadSampByte[2*j]     = 0;
					UploadSampByte[(2*j)+1] = 0;
					UploadRawByte[2*j]      = (uchar)(TK_md2value_origin[j]>>8);
					UploadRawByte[(2*j)+1]  = (uchar)(TK_md2value_origin[j]);
					UploadBaseByte[2*j]     = (uchar)(TK_md2average_backup[j]>>8);
					UploadBaseByte[(2*j)+1] = (uchar)(TK_md2average_backup[j]);	
				}
				if(TKMODE2_NUM < Tkchnum)
				{
					for(j = TKMODE2_NUM; j < Tkchnum; j++)
					{
						UploadSampByte[2*j]     = 0;
						UploadSampByte[(2*j)+1] = 0;
						UploadRawByte[2*j]      = 0;
						UploadRawByte[(2*j)+1]  = 0;
						UploadBaseByte[2*j]     = 0;
						UploadBaseByte[(2*j)+1] = 0;					
					}
				}
				PCT &= ~0x08;	//UART_TXΪ
				PCT |= 0x04;	//UART_RXΪ
	
				RX2EN = 1;		//UARTʹ	
				RX2IE = 1;		//ʹUARTж

				TX2EN = 1;		//UARTʹ	
				TX2IE = 0;		//ֹUARTжϣҪʱʹ

				GIE = 1;

				uart_send_flag = 1;
#endif
				md2Tkscan_numth = 0;		//ɨͨ0
				memset(TK_md2value_origin,0,2*TKMODE2_NUM);
			}
			PAT7 = 1;
			Config_TKIO2(Channel_md2table[md2Tkscan_numth]);	//TKܽTKSELĴ   
			TKCTL = 0x03;		//ʹܴʹģ飬TKGO=1ɨ
			clr_wdt();			//忴Ź
			while(!TKIF)
			{
				TKCTL = 0x03;	//ʹܴʹģ飬TKGO=1ɨ
			}	
					
			TKGO = 0;			//Ӧģر
			PAT7 = 0;	
			PA7 = 0;			//Cxŵ
			TKIF = 0;

			TK_md2value_origin[md2Tkscan_numth] = TKDAM;		//ȡɨ16λ
			TK_md2value_origin[md2Tkscan_numth]<<= 8;		
			TK_md2value_origin[md2Tkscan_numth] += TKDAL;

			uint cmp1,cmp2;
			cmp1 = (TK_md2value_origin[md2Tkscan_numth]);

			if(cmp1 != 0)
			{
				cmp2 = (uint)(TK_md2average_backup[md2Tkscan_numth] + TK_Sleep_Threshold);//50
				if(cmp1 > cmp2)
				{
					if(TK_md2average_backup[md2Tkscan_numth] == 0)
					{
						g_wakeup_flag = 0; 
						TK_md2average_backup[md2Tkscan_numth] = cmp1;
					}
					else
					{
						g_wakeup_flag = 1;

						//TK_state |= 1<<md2Tkscan_numth;
						//TKValueStru * ptr = &TK_Value_Arr[md2Tkscan_numth];
						//ptr->tk_value_filter = ptr->tk_value_average + Threshold_table[md2Tkscan_numth] + 10;
						//ptr->tk_value_origin += Threshold_table[md2Tkscan_numth] + 10;
						//ptr->tk_press_table = TK_Debounce_press + 2;
						//ptr->tk_release_table = 0;

						Customer_wakeupfromsleepmode_init();
						break;  
					}
				}
				else
				{
					g_wakeup_flag = 0; 
					//TK_md2average_backup[md2Tkscan_numth] = cmp1;  //Update the average
				}
				if(TK_md2average_backup[md2Tkscan_numth] != 0)  //Update the average
				{
				  if( cmp1 >TK_md2average_backup[md2Tkscan_numth])  // Solve the first time can not wakeup problem
					{ TK_md2average_backup[md2Tkscan_numth]++; }
					else 
					{TK_md2average_backup[md2Tkscan_numth]--;}
				}
			}
			md2Tkscan_numth++;		//ɨͨ+1
		}
	}
	else//˯ɨ»
	{
		union {
			uchar dl[2];
			uint  data;
		}tkdata;
		for(i = 0; i < TK_NUM; i++)
		{
			TKValueStru * ptr = &TK_Value_Arr[i];
			PAT7 = 1;
			Config_TKIO2(Channel_table[i]);	//TKܽTKSELĴ   
			TKCTL = 0x03;		//ʹܴʹģ飬TKGO=1ɨ
			clr_wdt();			//忴Ź
			while (!TKIF)
			{
				TKCTL = 0x03;	//ʹܴʹģ飬TKGO=1ɨ
			}						
			TKGO = 0;			//Ӧģر
			PAT7 = 0;	
			PA7 = 0;			//Cxŵ
			TKIF = 0;

			tkdata.dl[0] = TKDAL;
			tkdata.dl[1] = TKDAM;
			TK_value	 = tkdata.data;
			//#if  Max_Minvalueoff_filter ==ON 
			TK_value *=TK_Samples_perscan - 2;
			//#else
			//TK_value *=TK_Samples_perscan;
			//#endif			
			ptr->tk_value_filter = DataFilter(TK_value,ptr->tk_value_filter);	
			ptr->tk_value_average = DataFilter(ptr->tk_value_filter,ptr->tk_value_average);
		}
		TK_Sleep_Cnt = 0;
	}
#if TK_SLEEP_DEBUG == ON
	if(g_wakeup_flag == 0)
	{
		if(uart_send_flag)
		{
			while(uart_send_flag != 4) clr_wdt();
		}		
	}
	uart_send_flag = 0;
#endif
}

/*********************************************************
void Customer_wakeupfromsleepmode_init(void)
  : Ѻĳʼ ָʱ״̬ʼ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void Customer_wakeupfromsleepmode_init(void)
{
	uchar i; 
	for(i = 0; i < TKMODE2_NUM; i++)
	{
		TK_md2average_backup[i] = 0;
	}

	//MCUInit(); 
	//TKInit();    
	//OSCWP = 0x55;
	//OSCEN = 0;
	//HRCEN = 1;
	//LRCEN = 0;
	//while(!HRCON){} //ȴHRC״̬λ
	//OSCC1 = 0x00; //HRCʱԴ16M  1:1Ƶ
	//while(CHG){}
	//OSCWP = 0x5A;
	//SBOREN=1;

	//PAT = 0x80;
	//PBT = 0x58;
	//PCT = 0x05;
	//PET = 0x06;

	CLKG0 = 0xFF;   //ADCCE  T21CE  T20CE  -     T13CE    T12CE     T11CE     T10CE
	CLKG1 = 0x3F;   // -      -     TKCE  IICCE  UART3CE  UART2CE   UART1CE   UART0CE
	T10EN = 1;
	#if  TK_UARToutput_function == ON
	UARTInit();
	#endif
	//TKIE = 1;
	TKIF = 0;
	T10IE = 1;
	T10IF = 0;
	GIE = 1;
	TKCTL = 0x03;                 //ʹܴʹģ飬TKGO=1ɨ	 

 #if  TK_IOoutput_function ==ON
 Led_state=0;
	 #if TK_IOoutput_NUM >0
	 TK_IOoutput_port0 =LED_Off;
	 TK_IOoutput_trise0=0;
	 #endif
	  #if TK_IOoutput_NUM >1
	 TK_IOoutput_port1 =LED_Off;
	 TK_IOoutput_trise1=0;
	 #endif
	 #if TK_IOoutput_NUM >2
	 TK_IOoutput_port2 =LED_Off;
	 TK_IOoutput_trise2=0;
	 #endif
	  #if TK_IOoutput_NUM >3
	 TK_IOoutput_port3 =LED_Off;
	 TK_IOoutput_trise3=0;
	  #endif
	  #if TK_IOoutput_NUM >4
	 TK_IOoutput_port4 =LED_Off;
	 TK_IOoutput_trise4=0;
	  #endif
	  #if TK_IOoutput_NUM >5
	 TK_IOoutput_port5 =LED_Off;
	 TK_IOoutput_trise5=0;
	 #endif
	  #if TK_IOoutput_NUM >6
	 TK_IOoutput_port6 =LED_Off;
	 TK_IOoutput_trise6=0;
	  #endif
	  #if TK_IOoutput_NUM >7
	 TK_IOoutput_port7 =LED_Off;
	 TK_IOoutput_trise7=0;
	  #endif
	  #if TK_IOoutput_NUM >8
	 TK_IOoutput_port8 =LED_Off;
	 TK_IOoutput_trise8=0;
	  #endif
	  #if TK_IOoutput_NUM >9
	 TK_IOoutput_port9 =LED_Off;
	 TK_IOoutput_trise9=0;
	  #endif
	  #if TK_IOoutput_NUM >10
	 TK_IOoutput_port10 =LED_Off;
	 TK_IOoutput_trise10=0;
	  #endif
      #if TK_IOoutput_NUM >11
	 TK_IOoutput_port11 =LED_Off;
	 TK_IOoutput_trise11=0;
	  #endif
      #if TK_IOoutput_NUM >12
	 TK_IOoutput_port12 =LED_Off;
	 TK_IOoutput_trise12=0;
	  #endif
      #if TK_IOoutput_NUM >13
	 TK_IOoutput_port13 =LED_Off;
	 TK_IOoutput_trise13=0;
	  #endif
      #if TK_IOoutput_NUM >14
	 TK_IOoutput_port14 =LED_Off;
	 TK_IOoutput_trise14=0;
	  #endif
      #if TK_IOoutput_NUM >15
	 TK_IOoutput_port15 =LED_Off;
	 TK_IOoutput_trise15=0;
	  #endif

 #endif
}
#endif

//Show the Pressing Signal Value
void TK_pressing_fuc(void)
{
	uchar index_i;
	uchar index_k;
	ulong TK_state_char;
	uchar index_j = 0;
	
	TK_state_char = TK_state;

	for(index_i = 0;index_i < TK_NUM;index_i++)
	{
		if(TK_state_char & (1<<index_i))
		{
			index_j++;
			index_k = index_i;               //Keep the value
		}
	}
	
	if(index_j == 1) //Single press Refresh the view value
	{
		TKValueStru * ptr = &TK_Value_Arr[index_k];
		TK_pressing_value = (ptr->tk_value_filter) - (ptr->tk_value_average);
	}
	else
	{
		TK_pressing_value = 0;
	}
}


// Tk state machine
void Tk_service(void)
{
	uchar i;
	uchar Lock_average = 0;
	//uint  TK_Samples_perscan_temp   =5;    // ۼ趨1--16 16λ
	const uint *p;
	if(Opr_state & 0x4000)                // Data was full process it
	{          	
		#if Max_Minvalueoff_filter == ON  
		// Update the origin value  cut off the max and min value  
		uchar k;				
		uint Jitter = 0;	                            // 							   
		for(k = 0;k < TK_NUM;k++)
		{
			TK_Value_Arr[k].tk_value_origin -= TK_Value_Arr[k].tk_value_max;
			TK_Value_Arr[k].tk_value_origin -= TK_Value_Arr[k].tk_value_min;
			Jitter += TK_Value_Arr[k].tk_value_max - TK_Value_Arr[k].tk_value_min;
			//TK_Value_Arr[k].tk_value_max=0;
			//TK_Value_Arr[k].tk_value_min=0;
		}
		TK_jitter_Value = Jitter;                     // Refresh  the jitter value
		if(Jitter > Jitter_level1_Threshold)
		{							 
			Lock_averageconter = 250;
		}
		#endif

		TK_Base_percounter++;                 // Every come every ++  			  
		p = Threshold_table;		   
		for(i = 0;i < Tkchnum;i++)
		{ 
			ulong pow_2 = pow_ulong(i);
	     		
			TKValueStru * ptr = &TK_Value_Arr[i];

			#if (TK_UARToutput_function == ON)||(TK_IICoutput_function == ON)
			// Update the UART data        
			UploadSampByte[2*i]     = (uchar)(ptr->tk_value_origin>>8);
			UploadSampByte[(2*i)+1] = (uchar)(ptr->tk_value_origin);
			UploadRawByte[2*i]      = (uchar)(ptr->tk_value_filter>>8);
			UploadRawByte[(2*i)+1]  = (uchar)(ptr->tk_value_filter);
			UploadBaseByte[2*i]     = (uchar)(ptr->tk_value_average>>8);
			UploadBaseByte[(2*i)+1] = (uchar)(ptr->tk_value_average);		 
			#endif	
			// Origin data   Update value data	   
			ptr->tk_value_filter = DataFilter(ptr->tk_value_origin,ptr->tk_value_filter);		 
			if(ptr->tk_value_origin > (ptr->tk_value_average + p[i]))      		 
			{		   		                                                  
				Lock_average = 1;                                                          // This time not update average		 
			}		
			else 
			{
				Lock_average = 0;
				if(ptr->tk_press_table && (ptr->tk_press_table < TK_Debounce_press))                              // No key press  but at press conter state  (TK_state &((ulong)1<<i))==0
				{
					TK_Jitter_tolerance[i]++;
					if(TK_Jitter_tolerance[i] > Jitter_tolerance)
					{
						ptr->tk_press_table = 0;                             // Clear press counter
						TK_Jitter_tolerance[i] = 0;
					}
				}
				else 
				{
					TK_Jitter_tolerance[i] = 0;
				}
			}
			/********************************************** Check Trigger *****************************************/	

			uchar Mucheck = 1;
			if(Mult_inhibition((ptr->tk_value_filter - ptr->tk_value_average), TK_Mult_inhibition))
			{
				Mucheck = 1;		
			}
			else    //Be inhibition
			{
				Mucheck = 0;
				Lock_average = 0;  // Go on average
				// Clear state
				if(TK_state & (pow_2)) 
				{
					ptr->tk_release_table = TK_Debounce_release;
					TK_state &= ~pow_2;//~((ulong)1<<i);                    // Clear this trigger bit process	
					Customer_Keystatejustrelease();				   
					if(ptr->tk_timeout_counter!=0)
					{
						ptr->tk_timeout_counter = 0;
					}       // Close timer counter					  
					ptr->tk_D_value = 0;                                      // Save the Dlt value
				}
			}

			if((ptr->tk_value_filter > (ptr->tk_value_average + p[i]))&&Mucheck)  			
			{
				ptr->tk_press_table++;			   
				ptr->tk_release_table = 0;			   
				if(ptr->tk_press_table > TK_Debounce_press) 			
				{
					if(TK_jitter_Value < Jitter_level2_Threshold)
					{
						ptr->tk_press_table = TK_Debounce_press;			 
						TK_state |= pow_2;                                              // Set trigger process		
						Customer_Keystatejustpress();
						if(ptr->tk_timeout_counter == 0)
						{
							ptr->tk_timeout_counter = 1;
						}			  			 
						//#if  TK_Singlepress ==ON                                        // Save the Dlt value
						ptr->tk_D_value = ptr->tk_value_filter - ptr->tk_value_average;   // Save the Dlt value
						//#endif	
					}
					else
					{
						ptr->tk_press_table = 0;                                         // Clear 
					}	
				}
			}
			else
			{
				ptr->tk_press_table = 0;                             // Clear press counter	
				TK_Jitter_tolerance[i] = 0;		   
				if(TK_state & (pow_2))                        // Already press prepare to release check
				{			     
					if(ptr->tk_value_filter < (ptr->tk_value_average + ((p[i]*TK_Threshold_release)/10)))
					{				
						ptr->tk_release_table++;					
						if(ptr->tk_release_table > TK_Debounce_release)     // Release check
						{
							ptr->tk_release_table = TK_Debounce_release;
							TK_state &= ~pow_2;//~((ulong)1<<i);                    // Clear this trigger bit process
							Customer_Keystatejustrelease();					   
							if(ptr->tk_timeout_counter != 0)
							{
								ptr->tk_timeout_counter = 0;
							}       // Close timer counter
							#if  TK_Singlepress == ON                                    // Save the Dlt value
							ptr->tk_D_value = 0;      // Save the Dlt value
							#endif
						}				    
					}
					else
					{
						ptr->tk_release_table = 0;                                           // Clear the release counter
					}
				}
				else if((Lock_average == 0)&&(TK_Base_percounter > TK_BaseSamples_perscan)&&(Lock_averageconter == 0))
				{				 				  					    
					//Update averagedata  ;	
					ptr->tk_value_average = DataFilter(ptr->tk_value_filter,ptr->tk_value_average);			 	                       				 				 	                       
				}
			}
			/********************************************** Check Trigger *****************************************/
			ptr->tk_value_origin = 0;                                     // Clear the origin data  		 
		}	 

		TK_pressing_fuc();

		if(TK_Base_percounter > (TK_BaseSamples_perscan + 1))
		{
			TK_Base_percounter = 0;
		} // For next every  TK_BaseSamples_perscan  sample update
		Opr_state &=~0x4000;                             // Release this state
		//Single key press check 
		#if TK_Singlepress == ON      
		if(TK_state)                                                          // Any key pressed
		{                                     
			Singlekeyprocess();                                                  // Get Single key press state
		}
		else
		{
			TK_state_single = 0;
		}
		#endif
		#if TK_Lowpowermode == ON //޼ж
		if(TK_state)
		{
			TK_mode1_nopresstimer = 0;
		}       // Any key press clear the no key timer
		#endif
		Opr_state |= 0x8000;                              // Enable the scan enable bit			 	  		  
	}
}


// Check the time flag 
void Timer_check(void)
{
	uchar i;
	if(Timer_10ms > Timercounter_10ms) //125 *80 10ms
	{
		Timer_10ms = 0;
		#if TK_Lowpowermode == ON
		TK_mode1_nopresstimer++;       // Check switch to mode2 time
		#endif		  
		#if TK_UARToutput_function == ON
		if(Tx_timer)
		{
			Tx_timer++;
			if( Tx_timer >125)
			{
				Tx_timer = 0; 
				g_tp = 0;
			}       //Tx send 1s timeout send Reset
		}
		#endif
		Timer_counter++;
		if(Timer_counter > 5)  //50ms time out re start check TK scan
		{		
			Timer_counter = 0;              // Measure time	
			if(Opr_state &0x8000)       // Scan Enable
			{
				TKEN = 0;          // For TK module reset
				PAT |= 0x80;		// PA7 Must be Setinput			 
				VRC = TK_reg_VRC1;	//ʹADCVREF 2.6VVREF1=1.5V			 
				TKMODL = (uchar)TK_Amplifi_setting;//÷ŴϵĴ24λ
				TKMODM = (uchar)(TK_Amplifi_setting>>8);
				TKMODH = (uchar)(TK_Amplifi_setting>>16);
				TKMODU = (uchar)(TK_Amplifi_setting>>24);//Ŵϵ4λ=0

				TKEN = 1;			    //ʹܴλ
				TKTUN = TK_reg_TKTUN;	  //1ΣȽ˲ʱ8*ToscCxŵʱ32*ToscTKδΪ͵ƽ	
				TKGO = 0;			      //Ӧģر
				PA7 = 0;			      //Cxŵ
				PAT7 = 0;                 //Output0				 			 		  			   		                   	
				//TKScan();  
				PAT7 = 1;                 //When scan the PA7 must set input
				Config_TKIO2(Channel_table[Tkscan_numth]); 
				TKCTL = 0x03;                // ʹܴʹģ飬TKGO =1ɨ  
			}                
		}
		if(Lock_averageconter > 2)
		{
			Lock_averageconter--;
			if(Lock_averageconter < 5)
			{
				Lock_averageconter = 0;
			}		 
		}
		for(i = 0;i < Tkchnum;i++)
		{
			uint * ptr = &(TK_Value_Arr[i].tk_timeout_counter);// &TK_timeout_counter[i];
			if(*ptr == 0)                        // This num not press ignore
			{
				continue;
			}
			else
			{
				*ptr = *ptr + 1;		     
				if(*ptr >= TK_Press_timeout)        // Timeout force average and cancer the press state
				{
					*ptr = 0;			   
					Force_average(i);                 // Do force average 			   
				}
			}
		}
	}
}
// Get the TK channel data
void Update_TKdata(void)
{
	if(TK_value_get)
	{
		TK_value_get = 0;
		TK_Value_Arr[Tkscan_numth].tk_value_origin += TK_value;

		#if  Max_Minvalueoff_filter == ON  

		if(Tkscan_sampcounter == 0)                 //First value
		{
			TK_Value_Arr[Tkscan_numth].tk_value_max = TK_value;
			TK_Value_Arr[Tkscan_numth].tk_value_min = TK_value;
		}
		else if(TK_value > TK_Value_Arr[Tkscan_numth].tk_value_max)
		{
			TK_Value_Arr[Tkscan_numth].tk_value_max = TK_value;
		}		    
		else if(TK_value < TK_Value_Arr[Tkscan_numth].tk_value_min)
		{
			TK_Value_Arr[Tkscan_numth].tk_value_min = TK_value;
		}
		#endif

		Tkscan_numth++;
			// Default mode		  
		if(Tkscan_numth >= TK_NUM)
		{
			Tkscan_numth = 0;
			Tkscan_sampcounter++;
			if(Tkscan_sampcounter >= TK_Samples_perscan)
			{
				#if TK_Lowpowermode == ON
				if(TK_mode1_nopresstimer > TK_Mode0_nokeytoswitch_time)
				{
					g_wakeup_flag = 0;	//ѱ־0		
					TK_mode1_nopresstimer = 0;
					md2Tkscan_numth = 0; 
				}
				#endif
				Tkscan_sampcounter = 0;
				Opr_state |= 0x4000;                           // Set data is full let Tk_service process 
				//if(Opr_state &0x0010){TKIE =0;}				  // if at get baseline state	Clear the TKIE  						 
			}
		}			
		TKScan();	                                                 // Scan the active channel		
		if(Opr_state & 0x4000)
		{
			Opr_state &=~0x8000;
		}                                    // Clear the scan enable bit if data is full  wait data process  also have one data can be scan
	}
}
// Get the base data when power up or reset time
void Tk_getbaselinedata( void )
{
	uchar i;
	//             //Start scan
	TKGO = 0;			   //Ӧģر
	PA7 = 0;			       //Cxŵ
	PAT7 = 0;               //Output0
	Tkscan_numth = 0;
	PAT7 = 1;                 //When scan the PA7 must set input	 
	Opr_state &=~0x4000;
	Opr_state |= 0x0010;     
	Config_TKIO2(Channel_table[Tkscan_numth]);   
	// Set get baseline state
	TKCTL = 0x03;                // ʹܴʹģ飬TKGO =1ɨ	 
	while((Opr_state &0x4000) == 0) // Wait data is full
	{
		clr_wdt();
		Timer_check();               // Check if 10ms tick   
	}

	for(i = 0;i < Tkchnum;i++)
	{
		#if  Max_Minvalueoff_filter == ON  
		TK_Value_Arr[i].tk_value_origin -= TK_Value_Arr[i].tk_value_max;
		TK_Value_Arr[i].tk_value_origin -= TK_Value_Arr[i].tk_value_min;
		#endif

		TKValueStru * ptr = &TK_Value_Arr[i];
		ptr->tk_value_filter = ptr->tk_value_origin;
		ptr->tk_value_average = ptr->tk_value_origin;
		ptr->tk_value_origin = 0;

		//TK_value_filter[i]  =TK_value_origin[i];
		//TK_value_average[i] =TK_value_origin[i];
		//TK_value_origin[i]=0;
	}   
	Opr_state &=~0x4010;         // Clear again
	Opr_state |= 0x8000;          // Enable the scan enable bit
	TKIF = 0;
	// TKIE =1;
}


ulong Led_state = 0;
void TK_IO_output(void)
{ 
#if TK_IOoutput_function ==ON
    
  #if TK_IOLED_Function ==Indicate
	  uchar i=0;
	  ulong TK_state_temp;
	  #if TK_Singlepress==ON
	  TK_state_temp=TK_state_single;
	  #else
	  TK_state_temp=TK_state;
	  #endif

	  #if TK_IOoutput_NUM >0
	  if(TK_state_temp &((ulong)1<<i) )	  {TK_IOoutput_port0 =LED_On;}else {TK_IOoutput_port0=LED_Off;}i++;  
	  #endif
	  #if TK_IOoutput_NUM >1
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port1 =LED_On;}else { TK_IOoutput_port1=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >2
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port2 =LED_On;}else { TK_IOoutput_port2=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >3
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port3 =LED_On;}else { TK_IOoutput_port3=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >4
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port4 =LED_On;}else { TK_IOoutput_port4=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >5
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port5 =LED_On;}else { TK_IOoutput_port5=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >6
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port6 =LED_On;}else { TK_IOoutput_port6=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >7
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port7 =LED_On;}else { TK_IOoutput_port7=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >8
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port8 =LED_On;}else { TK_IOoutput_port8=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >9
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port9 =LED_On;}else { TK_IOoutput_port9=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >10
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port10 =LED_On;}else { TK_IOoutput_port10=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >11
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port11 =LED_On;}else { TK_IOoutput_port11=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >12
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port12 =LED_On;}else { TK_IOoutput_port12=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >13
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port13 =LED_On;}else { TK_IOoutput_port13=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >14
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port14 =LED_On;}else { TK_IOoutput_port14=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >15
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port15 =LED_On;}else { TK_IOoutput_port15=LED_Off;}i++;
	  #endif
	  

  #elif TK_IOLED_Function ==Toggle
      uchar i=0;
	  #if TK_IOoutput_NUM >0
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  { 	   
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port0 =LED_On;}else { TK_IOoutput_port0=LED_Off;}	 		  
	  }
	  i++;  
	  #endif
	  #if TK_IOoutput_NUM >1
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	   { 
	    Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port1 =LED_On;}else { TK_IOoutput_port1=LED_Off;}	
	   }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >2
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  { 
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port2 =LED_On;}else { TK_IOoutput_port2=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >3
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port3 =LED_On;}else { TK_IOoutput_port3=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >4
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port4 =LED_On;}else { TK_IOoutput_port4=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >5
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port5 =LED_On;}else { TK_IOoutput_port5=LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >6
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port6 =LED_On;}else { TK_IOoutput_port6 =LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >7
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port7 =LED_On;}else { TK_IOoutput_port7 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >8
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port8 =LED_On;}else { TK_IOoutput_port8 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >9
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port9 =LED_On;}else { TK_IOoutput_port9 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >10
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port10 =LED_On;}else { TK_IOoutput_port10 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >11
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port11 =LED_On;}else { TK_IOoutput_port11 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >12
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port12 =LED_On;}else { TK_IOoutput_port12 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >13
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port13 =LED_On;}else { TK_IOoutput_port13 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >14
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port14 =LED_On;}else { TK_IOoutput_port14 =LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >15
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port15 =LED_On;}else { TK_IOoutput_port15 =LED_Off;}
	  }
	   i++; 
	  #endif
	 
	  TK_state_backup =TK_state;
  #endif

#endif
}

