/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	common.h
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ͷļ
*  ע:	ͨͺͺ궨
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef   __COMMON_H__
#define   __COMMON_H__

#include <hic.h>

/*  */
typedef unsigned char  uchar;		//޷8λͱ
typedef unsigned int   uint;		//޷16λͱ 
typedef unsigned long  ulong;       //޷32λͱ

typedef unsigned char  INT8U;       //޷8λͱ
typedef signed   char  INT8S;       //з8λͱ
typedef unsigned int   INT16U;      //޷16λͱ 
typedef signed   int   INT16S;      //з16λͱ
typedef unsigned long  INT32U;      //޷32λͱ
typedef signed   long  INT32S;		//з32λͱ
typedef float          FP32;		//ȸͱ 
typedef double         FP64;		//˫ȸͱ

typedef unsigned char  u8;          //޷8λͱ
typedef unsigned int   u16;         //޷16λͱ 

typedef union 
{
	unsigned char byte;
	struct P8Bit
	{
	   unsigned char bit0:1;	// 1 
	   unsigned char bit1:1;	// 2 
	   unsigned char bit2:1;	// 3 
	   unsigned char bit3:1;	// 4 
	   unsigned char bit4:1;	// 5 
	   unsigned char bit5:1;	// 6 
	   unsigned char bit6:1;	// 7 
	   unsigned char bit7:1;	// 8 
	}bitn;
}BitAccess; 	

/* 궨 */
#define nop()		__Asm NOP
#define rst()		__Asm RST
#define sleep()		__Asm IDLE


#define FALSE		0
#define TRUE		1

#define WRONG		0
#define SUCCESS		1

#define ON          1
#define OFF         0
#define  Indicate   0
#define  Toggle     1

#endif
