/*********************************************************
*Copyright (C), 2021, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	main.c
*  :	AE Team
*  :	V1.0
*  :	2021/12/27
*  :	ʾ
*  ע:    ESD-SFB-7P201
			1ذ			
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************************************/
#include "stdlib.h"
#include "main.h"
#include "string.h"
/*********************************************************
:	void main()
  :	
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void main() 
{
	MCUInit();		          // MCUʼ Customer nY1eed change
							  // Customer powerup init 
	Delay100ms(1);
	TKInit();
	Timer_counter = 0;	  

	#if TK_Getdata_ISR  == ON
		Timerinit();	    
		it_vectors_init();
		TKIF = 0;                // ж	 	 	
		GIE  = 1;	 
		// TKIE =1;	                        
		Tk_getbaselinedata();     // initial data and average data
	#else
		Mainloop_counter = 0;
		Tk_getbase_loop();
	#endif

	#if TK_UARToutput_function == ON
		it_vectors_init();
		GIE = 1;
		UARTInit();
	#endif

    while(1)
    {
		clr_wdt();								//忴Ź
		#if TK_Lowpowermode == ON
		if(g_wakeup_flag == 0)
		{
			TKStandby();     //sleep run 
		}
		else
		#endif
		{
			#if TK_Getdata_ISR == OFF
			Check_data();
			#endif
			Tk_service();
			Timer_check();                       //Check if 10ms tick
			TK_IO_output();	 	
		}
	   //TK_state = TK_state;                //Ӧʱ򿪴ע ʹTK_state Ӧ״̬λ 32bit  Ϊ1 ɿΪ0
       //TK_state_single = TK_state_single;  //Ӧʱ򿪴ע ʹTK_state_single Ӧ״̬λ 32bit  Ϊ1 ɿΪ0 һЧ
    }
}

/***********************************************************
:	void MCUInit(void) 
  :	ϵͳʼӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void MCUInit(void) 
{
	ANSL = 0xFF;                           // Set Digital port 
	ANSH = 0xFF;                            
	PWEN = 3;		                       // BORENʹʱʹܵ͵ѹ⸴λʹWDTڲRCʱ
#if TK_Lowpowermode == ON			   // ͹ģʽʼ
	g_wakeup_flag = 1;
#if TK_UARToutput_function == ON
	uart_send_flag = 0;
#endif
	TK_mode1_nopresstimer = 0;
	memset(TK_md2value_origin,0,2*TKMODE2_NUM);
	memset(TK_md2average_backup,0,2*TKMODE2_NUM);    
#endif	
#if TK_IOoutput_function == ON
	Led_state=0;
	#if TK_IOoutput_NUM >0
	TK_IOoutput_port0 =LED_Off;
	TK_IOoutput_trise0=0;
	#endif
	#if TK_IOoutput_NUM >1
	TK_IOoutput_port1 =LED_Off;
	TK_IOoutput_trise1=0;
	#endif
	#if TK_IOoutput_NUM >2
	TK_IOoutput_port2 =LED_Off;
	TK_IOoutput_trise2=0;
	#endif
	#if TK_IOoutput_NUM >3
	TK_IOoutput_port3 =LED_Off;
	TK_IOoutput_trise3=0;
	#endif
	#if TK_IOoutput_NUM >4
	TK_IOoutput_port4 =LED_Off;
	TK_IOoutput_trise4=0;
	#endif
	#if TK_IOoutput_NUM >5
	TK_IOoutput_port5 =LED_Off;
	TK_IOoutput_trise5=0;
	#endif
	#if TK_IOoutput_NUM >6
	TK_IOoutput_port6 =LED_Off;
	TK_IOoutput_trise6=0;
	#endif
	#if TK_IOoutput_NUM >7
	TK_IOoutput_port7 =LED_Off;
	TK_IOoutput_trise7=0;
	#endif
#endif
}

/*********************************************************
:	void Delay100ms(uint time)
  :	ʱӳ
ֵ: timeʱλ100ms
ֵ: 
ֵ:  
**********************************************************/
void Delay100ms(uchar time)
{
	uchar i, j, k;
	for(i = 0; i < time; i++)
	{
		for(j = 0; j < 100; j++)			
		{
			for(k = 0; k < 249; k++)
			{
				nop();
				nop();
				//nop();
				clr_wdt();
			}
		}
	}
}

/*********************************************************
void UARTInit(void)
  :	UARTʼӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
#if TK_UARToutput_function == ON
void UARTInit(void)
{
	PCT1 = 0;	//UART_TXΪ	
	PCT0 = 1;	//UART_RXΪ
	#if TK_UARToutput_Databit == 8
	TXM	= 0;	//8λݸʽ
	#elif TK_UARToutput_Databit == 9
	TXM	= 1;	//9λݸʽ
	#endif
	BRGH = 1;	//ģʽ
	#if  TK_UARToutput_Baudrate == 115200
	BRR	= 8;	//115200bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 57600
	BRR	= 16;	//57600bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 38400
	BRR	= 25;	//38400bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 19200
	BRR	= 51;	//19200bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 9600
	BRR	= 103;	//9600bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#elif TK_UARToutput_Baudrate == 4800
	BRR	= 207;	//4800bps=Fosc/(16(BRR<7:0> + 1))@16MHz 
	#endif
	RXEN = 1;	//UARTʹ	
	RXIE = 1;	//ʹUARTж

	TXEN = 1;	//UARTʹ	
	TXIE = 0;	//ֹUARTжϣҪʱʹ
	g_tp = 0;
    ChannelMask = 0xFFFFFFFF;
}
#endif

/*********************************************************
void Customer_Keystatejustpress(void)
  : ͨոռ⵽״̬
ֵ: 
ֵ: TK_state
ֵ:  
**********************************************************/
void Customer_Keystatejustpress(void)
{ //TK_state was just freshed  you can use the  parameter as you want
 
}

/*********************************************************
void Customer_Keystatejustrelease(void)
  : ͨոռ⵽ͷ
ֵ: 
ֵ: TK_state
ֵ:  
**********************************************************/
void Customer_Keystatejustrelease(void)
{ //TK_state was just freshed  you can use the  parameter as you want
 
}


