/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:	tkm_config.c
*  :	Flynn Yin
*  :	V3.01
*  :	2019/1
*  :	ó
*  ע:    ESD-SFB-7P201
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "common.h"
#include "stdlib.h"
#include "main.h"
#include "tkm_config.h"

//=========================================================================================================
ulong pow_ulong(uchar i)
{
	return ((ulong)1<<i);
}
/* TK */

	#if    TK_NUM ==1
	  const uchar Channel_table[TK_NUM]={TK_Channel0};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0};	  
	#elif  TK_NUM ==2
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1};
	#elif  TK_NUM ==3
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2};
	#elif  TK_NUM ==4
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3};
	#elif  TK_NUM ==5
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4};
	#elif  TK_NUM ==6
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5};
	#elif  TK_NUM ==7
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6};
	#elif  TK_NUM ==8
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7};
	#elif  TK_NUM ==9
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8};
	#elif  TK_NUM ==10
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9};
	#elif  TK_NUM ==11
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10};
	#elif  TK_NUM ==12
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11};
	#elif  TK_NUM ==13
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12};
	#elif  TK_NUM ==14
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13};
	#elif  TK_NUM ==15
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14};
	#elif  TK_NUM ==16
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15};
	#elif  TK_NUM ==17
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16};
	#elif  TK_NUM ==18
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17};
    #elif  TK_NUM ==19
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18};
    #elif  TK_NUM ==20
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18,TK_Channel19};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18,TK_Threshold_Channel19};
    #elif  TK_NUM ==21
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18,TK_Channel19,TK_Channel20};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18,TK_Threshold_Channel19,TK_Threshold_Channel20};
    #elif  TK_NUM ==22
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18,TK_Channel19,TK_Channel20,TK_Channel21};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18,TK_Threshold_Channel19,TK_Threshold_Channel20,TK_Threshold_Channel21};
    #elif  TK_NUM ==23
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18,TK_Channel19,TK_Channel20,TK_Channel21,TK_Channel22};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18,TK_Threshold_Channel19,TK_Threshold_Channel20,TK_Threshold_Channel21,TK_Threshold_Channel22};
	#elif  TK_NUM ==24
	  const uchar Channel_table[TK_NUM]={TK_Channel0,TK_Channel1,TK_Channel2,TK_Channel3,TK_Channel4,TK_Channel5,TK_Channel6,TK_Channel7,TK_Channel8,TK_Channel9,TK_Channel10,TK_Channel11,TK_Channel12,TK_Channel13,TK_Channel14,TK_Channel15,TK_Channel16,TK_Channel17,TK_Channel18,TK_Channel19,TK_Channel20,TK_Channel21,TK_Channel22,TK_Channel23};
	  const uint Threshold_table[TK_NUM]={TK_Threshold_Channel0,TK_Threshold_Channel1,TK_Threshold_Channel2,TK_Threshold_Channel3,TK_Threshold_Channel4,TK_Threshold_Channel5,TK_Threshold_Channel6,TK_Threshold_Channel7,TK_Threshold_Channel8,TK_Threshold_Channel9,TK_Threshold_Channel10,TK_Threshold_Channel11,TK_Threshold_Channel12,TK_Threshold_Channel13,TK_Threshold_Channel14,TK_Threshold_Channel15,TK_Threshold_Channel16,TK_Threshold_Channel17,TK_Threshold_Channel18,TK_Threshold_Channel19,TK_Threshold_Channel20,TK_Threshold_Channel21,TK_Threshold_Channel22,TK_Threshold_Channel23};
	#endif 
/****************************************************For Mode2 setting***************************************************************************/
//#if (TK_MODE2 ==ON)||(TK_Powersavemode_function ==ON)
   #if    TKMODE2_NUM ==1
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0};	  
	#elif  TKMODE2_NUM ==2
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1};
	#elif  TKMODE2_NUM ==3
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2};
	#elif  TKMODE2_NUM ==4
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3};
	#elif  TKMODE2_NUM ==5
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4};
	#elif  TKMODE2_NUM ==6
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5};
	#elif  TKMODE2_NUM ==7
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6};
	#elif  TKMODE2_NUM ==8
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7};
	#elif  TKMODE2_NUM ==9
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8};
	#elif  TKMODE2_NUM ==10
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9};
	#elif  TKMODE2_NUM ==11
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10};
	#elif  TKMODE2_NUM ==12
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11};
	#elif  TKMODE2_NUM ==13
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12};
	#elif  TKMODE2_NUM ==14
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13};
	#elif  TKMODE2_NUM ==15
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14};
	#elif  TKMODE2_NUM ==16
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15};
	#elif  TKMODE2_NUM ==17
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16};
	#elif  TKMODE2_NUM ==18
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17};
    #elif  TKMODE2_NUM ==19
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18};
    #elif  TKMODE2_NUM ==20
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18,TKMODE2_Threshold_Channel19};
    #elif  TKMODE2_NUM ==21
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18,TKMODE2_Threshold_Channel19,TKMODE2_Threshold_Channel20};
    #elif  TKMODE2_NUM ==22
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18,TKMODE2_Threshold_Channel19,TKMODE2_Threshold_Channel20,TKMODE2_Threshold_Channel21};
    #elif  TKMODE2_NUM ==23
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21,TKMODE2_Channel22};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18,TKMODE2_Threshold_Channel19,TKMODE2_Threshold_Channel20,TKMODE2_Threshold_Channel21,TKMODE2_Threshold_Channel22};
	#elif  TKMODE2_NUM ==24
	  const uchar Channel_md2table[TKMODE2_NUM]={TKMODE2_Channel0,TKMODE2_Channel1,TKMODE2_Channel2,TKMODE2_Channel3,TKMODE2_Channel4,TKMODE2_Channel5,TKMODE2_Channel6,TKMODE2_Channel7,TKMODE2_Channel8,TKMODE2_Channel9,TKMODE2_Channel10,TKMODE2_Channel11,TKMODE2_Channel12,TKMODE2_Channel13,TKMODE2_Channel14,TKMODE2_Channel15,TKMODE2_Channel16,TKMODE2_Channel17,TKMODE2_Channel18,TKMODE2_Channel19,TKMODE2_Channel20,TKMODE2_Channel21,TKMODE2_Channel22,TKMODE2_Channel23};
	  const uint Threshold_md2table[TKMODE2_NUM]={TKMODE2_Threshold_Channel0,TKMODE2_Threshold_Channel1,TKMODE2_Threshold_Channel2,TKMODE2_Threshold_Channel3,TKMODE2_Threshold_Channel4,TKMODE2_Threshold_Channel5,TKMODE2_Threshold_Channel6,TKMODE2_Threshold_Channel7,TKMODE2_Threshold_Channel8,TKMODE2_Threshold_Channel9,TKMODE2_Threshold_Channel10,TKMODE2_Threshold_Channel11,TKMODE2_Threshold_Channel12,TKMODE2_Threshold_Channel13,TKMODE2_Threshold_Channel14,TKMODE2_Threshold_Channel15,TKMODE2_Threshold_Channel16,TKMODE2_Threshold_Channel17,TKMODE2_Threshold_Channel18,TKMODE2_Threshold_Channel19,TKMODE2_Threshold_Channel20,TKMODE2_Threshold_Channel21,TKMODE2_Threshold_Channel22,TKMODE2_Threshold_Channel23};
	#endif 

//#endif 
/****************************************************For Mode2 setting***************************************************************************/
/****************************************************For Matrix setting***************************************************************************/
//#if TK_Matrix_Function ==ON
const uchar Channel_MatrixRowtable[TK_Matrix_Row_NUM] =
{
 #if TK_Matrix_Row_NUM >0
	TK_Matrix_Row0
 #endif
 #if TK_Matrix_Row_NUM >1
	,TK_Matrix_Row1	  
 #endif
 #if TK_Matrix_Row_NUM >2
	,TK_Matrix_Row2	  
 #endif
 #if TK_Matrix_Row_NUM >3
	,TK_Matrix_Row3	  
 #endif
 #if TK_Matrix_Row_NUM >4
	,TK_Matrix_Row4	  
 #endif
#if TK_Matrix_Row_NUM >5
	,TK_Matrix_Row5	  
 #endif
#if TK_Matrix_Row_NUM >6
	,TK_Matrix_Row6	  
 #endif
#if TK_Matrix_Row_NUM >7
	,TK_Matrix_Row7	  
 #endif
#if TK_Matrix_Row_NUM >8
	,TK_Matrix_Row8	  
 #endif
#if TK_Matrix_Row_NUM >9
	,TK_Matrix_Row9	  
 #endif
#if TK_Matrix_Row_NUM >10
	,TK_Matrix_Row10	  
 #endif
#if TK_Matrix_Row_NUM >11
	,TK_Matrix_Row11	  
 #endif
#if TK_Matrix_Row_NUM >12
	,TK_Matrix_Row12	  
 #endif
#if TK_Matrix_Row_NUM >13
	,TK_Matrix_Row13	  
 #endif
}; 
const uchar Channel_MatrixColumetable[TK_Matrix_Column_NUM]=
{
 #if TK_Matrix_Column_NUM >0
	TK_Matrix_Column0	  
 #endif
 #if TK_Matrix_Column_NUM >1
	,TK_Matrix_Column1	  
 #endif
 #if TK_Matrix_Column_NUM >2
	,TK_Matrix_Column2	  
 #endif
 #if TK_Matrix_Column_NUM >3
	,TK_Matrix_Column3	  
 #endif
 #if TK_Matrix_Column_NUM >4
	,TK_Matrix_Column4	  
 #endif
#if TK_Matrix_Column_NUM >5
	,TK_Matrix_Column5	  
 #endif
#if TK_Matrix_Column_NUM >6
	,TK_Matrix_Column6	  
 #endif
#if TK_Matrix_Column_NUM >7
	,TK_Matrix_Column7	  
 #endif
#if TK_Matrix_Column_NUM >8
	,TK_Matrix_Column8	  
 #endif
#if TK_Matrix_Column_NUM >9
	,TK_Matrix_Column9	  
 #endif
#if TK_Matrix_Column_NUM >10
	,TK_Matrix_Column10	  
 #endif
#if TK_Matrix_Column_NUM >11
	,TK_Matrix_Column11	  
 #endif
#if TK_Matrix_Column_NUM >12
	,TK_Matrix_Column12	  
 #endif
#if TK_Matrix_Column_NUM >13
	,TK_Matrix_Column13	  
 #endif
};  
//#endif
/****************************************************For Matrix setting***************************************************************************/
/****************************************************For Slider setting***************************************************************************/
//#if TK_Slider_Function ==ON
const uchar Channel_Slidertable[TK_Slider_Levels] =
{
 #if TK_Slider_Levels >0
	TK_Slider_level0	  
 #endif
 #if TK_Slider_Levels >1
	,TK_Slider_level1	  
 #endif
 #if TK_Slider_Levels >2
	,TK_Slider_level2	  
 #endif
 #if TK_Slider_Levels >3
	,TK_Slider_level3	  
 #endif
 #if TK_Slider_Levels >4
	,TK_Slider_level4	  
 #endif
#if TK_Slider_Levels >5
	,TK_Slider_level5	  
 #endif
#if TK_Slider_Levels >6
	,TK_Slider_level6	  
 #endif
#if TK_Slider_Levels >7
	,TK_Slider_level7	  
 #endif
#if TK_Slider_Levels >8
	,TK_Slider_level8	  
 #endif
#if TK_Slider_Levels >9
	,TK_Slider_level9	  
 #endif
#if TK_Slider_Levels >10
	,TK_Slider_level10	  
 #endif
#if TK_Slider_Levels >11
	,TK_Slider_level11	  
 #endif
#if TK_Slider_Levels >12
	,TK_Slider_level12	  
 #endif
#if TK_Slider_Levels >13
	,TK_Slider_level13	  
 #endif
};
//#endif
/****************************************************For Slider setting***************************************************************************/
/****************************************************For Wheel setting***************************************************************************/
//#if TK_Wheel_Function ==ON
const uchar Channel_Wheeltable[TK_Wheel_Levels] =
{
#if TK_Wheel_Levels >0
	TK_Wheel_level0 
 #endif
 #if TK_Wheel_Levels >1
	,TK_Wheel_level1	  
 #endif
 #if TK_Wheel_Levels >2
	,TK_Wheel_level2	  
 #endif
 #if TK_Wheel_Levels >3
	,TK_Wheel_level3	  
 #endif
 #if TK_Wheel_Levels >4
	,TK_Wheel_level4	  
 #endif
#if TK_Wheel_Levels >5
	,TK_Wheel_level5	  
 #endif
#if TK_Wheel_Levels >6
	,TK_Wheel_level6	  
 #endif
#if TK_Wheel_Levels >7
	,TK_Wheel_level7	  
 #endif
#if TK_Wheel_Levels >8
	,TK_Wheel_level8	  
 #endif
#if TK_Wheel_Levels >9
	,TK_Wheel_level9	  
 #endif
#if TK_Wheel_Levels >10
	,TK_Wheel_level10	  
 #endif
#if TK_Wheel_Levels >11
	,TK_Wheel_level11	  
 #endif
#if TK_Wheel_Levels >12
	,TK_Wheel_level12	  
 #endif
#if TK_Wheel_Levels >13
	,TK_Wheel_level13	  
 #endif

};
//#endif
/****************************************************For Wheel setting***************************************************************************/

//#if (TK_UARToutput_function ==ON)||(TK_IICoutput_function ==ON)

uchar g_com;				//
uchar g_length;				//ݳ
uchar g_rp;					//ָ
uchar g_tp;					//ָ
uchar g_checksum;			//У
uchar Tx_timer;
uchar UploadSampByte[(TK_NUM*2)+5];	//ֽ
uchar UploadRawByte[(TK_NUM*2)+5];		//˲ֽ
uchar UploadBaseByte[(TK_NUM*2)+5];	//ֽ
uchar UploadBuf[(TK_NUM*2)+5];	        //ͻ

//#endif
const uchar ChannelSum    = TK_NUM;	        //ʵʰֵ tkm_config.h޸
const uchar ChannelSummd2 = TKMODE2_NUM;	//ʵʰֵ tkm_config.h޸
const uchar DF_MCU_Type   = 201;
const uchar DF_TK_MODE2   = TK_MODE2;
const uchar DF_TK_Matrix_Row_NUM     =TK_Matrix_Row_NUM;
const uchar DF_TK_Matrix_Column_NUM =TK_Matrix_Column_NUM;
const uchar DF_TK_Slider_Levels =TK_Slider_Levels;
const uchar DF_TK_Slider_poles_setting =TK_Slider_poles_setting;
const uchar DF_TK_Wheel_Levels  =TK_Wheel_Levels;
const uchar DF_TK_Wheel_poles_setting  =TK_Wheel_poles_setting;
const uchar DF_TK_Jittersample  =TK_Jittersample;
const uchar DF_TK_Singlepress   =TK_Singlepress;


/* TKӲ */
//const uchar REG_VRC1 = 0x82;	//ʹADCVREF 2.6VVREF1=1.5V
//const uchar REG_ACPC4 = 0x11;	//ʹܱȽC4ڲVREF1
//const uchar REG_TKMODL = 0xFF;	//÷ŴϵĴ=0x1FFFFF FFFFF
//const uchar REG_TKMODM = 0xFF;
//const uchar REG_TKMODH = 0x0F;	//00
//const uchar REG_TKMODU = 0x00;	//Ŵϵ4λ=0
//const uchar REG_TKTUN = 0x30;	//1ΣȽ˲ʱ8*ToscCxŵʱ32*ToscTKδΪ͵ƽ
//const uchar REG_TKSEL = 0x40;	//趨Ӧͨŵռձ1:2ɨƵfosc/4ͰֽڱΪ0

uint  Opr_state;
/*
Bit15  Scan Enable bit   1 on 0 off
Bit14  Tempdata is full  1 full 0 receive
Bit13  Jillter sample enable bit  1 Enable     0  Disable
Bit12  Once scan complete bit     1 complete   0  busy
Bit11  Slider bit    1 Slider was be touch 0 not be touch
Bit10  Wheel  bit    1 Wheel  was be touch 0 not be touch
Bit9   Matrix Row bit     1   was be touch 0 not be touch
Bit8   Matrix Column bit  1   was be touch 0 not be touch
Bit7   Mode bit  0  Mode default  1  Mode2  
Bit6   Mode switch start switching  if 1 else 0       
Bit5   Powersave flag setting if 1 else 0
Bit4
Bit3
Bit2
Bit1
Bit0
*/

uint  TK_value;             //Temp value after scan
uint  Timer_counter;        //Timer counter
uchar T8n_back;             
uchar Tkchnum;              //TK num
uchar Tkscan_numth;         //The active numth
uchar Tkscan_sampcounter;   //Sample counter  1--TK_Samples_perscan

uchar TK_Jitter_tolerance[TK_NUM];
uint  TK_jitter_Value;
uint TK_value_origin[TK_NUM];//  ={0};   // Origin      data
uint TK_value_filter[TK_NUM];//  ={0};   // Been filter data
uint TK_value_average[TK_NUM];// ={0};   // Base line   data
uint TK_timeout_counter[TK_NUM];// ={0};  // Base line   data
uint TK_average_backup[TK_NUM];//  ={0};
uint TK_md2average_backup[TK_NUM];//  ={0};
uint TK_value_origin_max[TK_NUM];
uint TK_value_origin_min[TK_NUM];
uchar TK_press_table[TK_NUM];//  ={0};     // TkPress counter
uchar TK_release_table[TK_NUM];// ={0};   // TkRelease counter

//#if  TK_Singlepress ==ON  
uint TK_D_value[TK_NUM]; // ={0};         // D value  data to see if which one is the most one
//#endif

//#if  TK_Matrix_Function ==ON  
uint TK_D_Rvalue[TK_Matrix_Row_NUM]; // ={0};             // D value  data to see if which one is the most one
uint TK_D_Cvalue[TK_Matrix_Column_NUM]; // ={0};         // D value  data to see if which one is the most one
ulong TK_Matrix_RID;
ulong TK_Matrix_CID;
uint  TK_Matrix_value;
uchar Matrix_timer;                                  // Time to clear
//#endif

//#if  TK_Slider_Function ==ON  
int  TK_D_slider[TK_Slider_Levels]; // ={0};         // D value  data to see if which one is the most one
ulong TK_slider_ID;
uint  TK_slider_value;
uchar Slider_timer;                             // Time to clear
//#endif

//#if  TK_Wheel_Function ==ON  
int  TK_D_wheel[TK_Wheel_Levels]; // ={0};           // D value  data to see if which one is the most one
ulong TK_wheel_ID;
uint  TK_wheel_value;
uchar Wheel_timer;                              // Time to clear
//#endif

//#if TK_Powersavemode_function  ==ON
uint  TK_mode1_nopresstimer;
//#endif

uchar Lock_averageconter;
uchar TK_press_counter;
uchar TK_release_counter;
ulong TK_state;
ulong TK_state_backup;
ulong TK_state_single;
uint  TK_pressing_value;

ulong Led_state;
uint  TK_Base_percounter;
uint  TK_Jitter_delay;
uchar TK_Jitter_timer;
uchar TK_modeth;
uchar Powersave_switching;
/*********************************************************
:	void TKInit(void)
  :	ʼӳ
ֵ: 
**********************************************************/

void TKInit(void )
{
 uchar i;
 PBT |= 0x80;		// PB7 Must be Setinput
 // TK init for test
 VRC1  = TK_reg_VRC1;	//ʹADCVREF 2.6VVREF1=1.4V
 ACPC4 = TK_reg_ACPC4;	//ʹܱȽC4ڲVREF1

 TKMODL = (uchar)TK_Amplifi_setting;//÷ŴϵĴ24λ
 TKMODM = (uchar)(TK_Amplifi_setting>>8);
 TKMODH = (uchar)(TK_Amplifi_setting>>16);
 TKMODU = (uchar)(TK_Amplifi_setting>>24);//Ŵϵ4λ=0

 TKEN = 1;			    //ʹܴλ
 TKTUN =TK_reg_TKTUN;	//1ΣȽ˲ʱ8*ToscCxŵʱ32*ToscTKδΪ͵ƽ	
 Tkchnum =TK_NUM;
 Tkscan_numth =0;
 Tkscan_sampcounter=0;
 Opr_state=0x8000;      //Enable scan
  #if  MCU_Type ==201
  TKSEL = 0x40;           // 趨Ӧͨŵռձ1:2ɨƵfosc/4
  #elif MCU_Type ==202
  TKSEL = 0x80;           // 趨Ӧͨŵռձ1:2ɨƵfosc/4
  #endif
 //ANSL = 0xFF;	//ð˿Ϊ
 //ANSH = 0xFF;	//ð˿Ϊ
 TK_state=0;
 TK_state_backup=0;
 TK_Base_percounter=0;
 //TK_modeth =0;     //if 1 set the default mode if 2 set the mode 2

 for (i=0;i<TK_NUM;i++)
   {
    TK_timeout_counter[i]=0;
	TK_press_table[i]   =0;
	TK_release_table[i] =0;
	TK_value_origin[i]  =0;
	TK_D_value[i]       =0;
	TK_Jitter_tolerance[i] = 0;
   }

  #if  TK_Guardsensor_output ==ON
  TK_Guardsensor_setting=1;                          // Set output 1
  TK_GuardIOtrise_setting =0;                        // SET Guard IO output mode
  #endif

  #if  TK_Slider_Function ==ON 
  TK_slider_ID =0;
  
  for (i=0;i<TK_Slider_Levels;i++)
  {
   TK_slider_ID |=((ulong)1<<Channel_Slidertable[i]);
  }
  #endif
   TK_slider_value=0; 
  #if  TK_Wheel_Function ==ON
   TK_wheel_ID =0;
   
  for (i=0;i<TK_Wheel_Levels;i++)
  {
   TK_wheel_ID |=((ulong)1<<Channel_Wheeltable[i]);
  }
  #endif
  TK_wheel_value=0; 
  #if  TK_Matrix_Function ==ON 
  TK_Matrix_RID=0;
  TK_Matrix_CID=0;
  
  for (i=0;i<TK_Matrix_Row_NUM;i++)
  {
   TK_Matrix_RID |=((ulong)1<<Channel_MatrixRowtable[i]);
  }
   for (i=0;i<TK_Matrix_Column_NUM;i++)
  {
   TK_Matrix_CID |=((ulong)1<<Channel_MatrixColumetable[i]);
  }
  #endif
  TK_Matrix_value=0;
  #if TK_Powersavemode_function  ==ON
   TK_mode1_nopresstimer =0;
   Opr_state |=0x0020;                 // Set Lowpower mode flag

 uint value_temp;
 clr_wdt();	                           // 忴Ź wakeup clear
 value_temp =TK_Wdttimer_sleepsetting;
 value_temp >>=5;
 value_temp |=0x08;
 WDTC =(uchar)(value_temp &0x0F);     // Set wdt time

 if( TK_Wdttimer_sleepsetting >=2048 ){ WDTC=0x0F;}
 else if( TK_Wdttimer_sleepsetting >=1024 ){ WDTC =0x0E;}
 else if( TK_Wdttimer_sleepsetting >=512 ) { WDTC =0x0D;}
 else if( TK_Wdttimer_sleepsetting >=256 ) { WDTC =0x0C;}
 else if( TK_Wdttimer_sleepsetting >=128 ) { WDTC =0x0B;}
 else if( TK_Wdttimer_sleepsetting >=64 )  { WDTC =0x0A;}
 else if( TK_Wdttimer_sleepsetting >=32 )  { WDTC =0x09;}
 else if( TK_Wdttimer_sleepsetting >=16 )  { WDTC =0x08;}
 #endif

}

/*********************************************************
:	void TK_IO_output(void)
  :	ʼӳ
ֵ: 
**********************************************************/
void TK_IO_output(void)
{ 
#if TK_IOoutput_function ==ON
    
  #if TK_IOLED_Function ==Indicate
	  uchar i=0;
	  ulong TK_state_temp;
	  #if TK_Singlepress==ON
	  TK_state_temp=TK_state_single;
	  #else
	  TK_state_temp=TK_state;
	  #endif

	  #if TK_IOoutput_NUM >0
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port0 =LED_On;}else { TK_IOoutput_port0=LED_Off;}i++;  
	  #endif
	  #if TK_IOoutput_NUM >1
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port1 =LED_On;}else { TK_IOoutput_port1=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >2
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port2 =LED_On;}else { TK_IOoutput_port2=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >3
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port3 =LED_On;}else { TK_IOoutput_port3=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >4
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port4 =LED_On;}else { TK_IOoutput_port4=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >5
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port5 =LED_On;}else { TK_IOoutput_port5=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >6
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port6 =LED_On;}else { TK_IOoutput_port6=LED_Off;}i++;
	  #endif
	  #if TK_IOoutput_NUM >7
	  if(TK_state_temp &((ulong)1<<i) ){ TK_IOoutput_port7 =LED_On;}else { TK_IOoutput_port7=LED_Off;}i++;
	  #endif
	  
  #elif TK_IOLED_Function ==Toggle
      uchar i=0;
	  #if TK_IOoutput_NUM >0
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  { 
	   //TK_IOoutput_port0^=1;                  //Error  ???
	   //TK_IOoutput_port0=~TK_IOoutput_port0;  //Error  ???
	   //if(TK_IOoutput_port0==1){TK_IOoutput_port0 =0;}else{TK_IOoutput_port0 =1;}//Error ???
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port0 =LED_On;}else { TK_IOoutput_port0=LED_Off;}	 		  
	  }
	  i++;  
	  #endif
	  #if TK_IOoutput_NUM >1
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	   { 
	    Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port1 =LED_On;}else { TK_IOoutput_port1=LED_Off;}	
	   }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >2
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  { 
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port2 =LED_On;}else { TK_IOoutput_port2=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >3
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	   if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port3 =LED_On;}else { TK_IOoutput_port3=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >4
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port4 =LED_On;}else { TK_IOoutput_port4=LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >5
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port5 =LED_On;}else { TK_IOoutput_port5=LED_Off;}
	  }
	   i++; 
	  #endif
	  #if TK_IOoutput_NUM >6
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port6 =LED_On;}else { TK_IOoutput_port6 =LED_Off;}
	  }
	  i++; 
	  #endif
	  #if TK_IOoutput_NUM >7
	  if((TK_state &((ulong)1<<i))&&((TK_state_backup &((ulong)1<<i))==0) )
	  {
	   Led_state^=((ulong)1<<i);
	    if(Led_state &((ulong)1<<i) ){ TK_IOoutput_port7 =LED_On;}else { TK_IOoutput_port7 =LED_Off;}
	  }
	   
	  #endif
	  TK_state_backup =TK_state;
  #endif

#endif
}

//Show the Pressing Signal Value
void TK_pressing_fuc(void)
{
	uchar index_i;
	uchar index_k;
	ulong TK_state_char;
	uchar index_j=0;
	
	TK_state_char =TK_state;

    for (index_i=0;index_i<TK_NUM;index_i++)
    {
	   if(TK_state_char &(1<<index_i))
	   {
	      index_j++;
	      index_k=index_i;               //Keep the value
	    }
     }
	
	if(index_j==1) //Single press Refresh the view value
	{
		 TK_pressing_value =TK_value_filter[index_k]-TK_value_average[index_k];
	}
	else
	{
		 TK_pressing_value = 0;
	}
}

void Update_origindata(void)
{
	#if  Max_Minvalueoff_filter ==ON  
																		  // Update the origin value  cut off the max and min value  
		uchar k;				
		uint Jitter =0;	                            // 							   
		for (k=0;k<TK_NUM;k++)
		{
		TK_value_origin[k] -=TK_value_origin_max[k];
		TK_value_origin[k] -=TK_value_origin_min[k];
		Jitter +=TK_value_origin_max[k] - TK_value_origin_min[k];
		//TK_Value_Arr[k].tk_value_max=0;
		//TK_Value_Arr[k].tk_value_min=0;
		}
		TK_jitter_Value =Jitter;                     // Refresh  the jitter value
		if(Jitter >Jitter_level1_Threshold)
		{							 
		Lock_averageconter =250;
		}
		#endif
}
void Update_upload_data(void)
{
		uchar i;
		#if  (TK_UARToutput_function ==ON)||(TK_IICoutput_function ==ON)
                                             // Update the UART data
         for (i=0;i<TK_NUM;i++)
	     {
		  UploadSampByte[2*i]     =(uchar)(TK_value_origin[i]>>8);
		  UploadSampByte[(2*i)+1] =(uchar)(TK_value_origin[i]);
		  UploadRawByte[2*i]      =(uchar)(TK_value_filter[i]>>8);
		  UploadRawByte[(2*i)+1]  =(uchar)(TK_value_filter[i]);
		  UploadBaseByte[2*i]     =(uchar)(TK_value_average[i]>>8);
		  UploadBaseByte[(2*i)+1] =(uchar)(TK_value_average[i]);
		 }
        #endif
}
uint TK_Sleep_Cnt;
void Tk_service(void)
{
	uchar i;
	uchar Lock_average=0;
	//uint  TK_Samples_perscan_temp   =5;    // ۼ趨1--16 16λ
	uint  TK_Threshold_release_temp ;        // 0.4-0.9 ɿ趨0.530ɿҪ15  5==50%
	uint  TK_Samplevalue_step_temp  ;        // 趨1--65535 ֮һ
	uint  TK_basevalue_step_temp    ;        // ߲趨  1--65535 ȲҪС
	uint  TK_BaseSamples_perscan_temp ;      // ߸ 趨1--65535
	uint  TK_Debounce_press_temp      ;      // µĴ趨
	uint  TK_Debounce_release_temp    ;      // 뿪Ĵ趨
	const uint *p;

	if( Opr_state &0x0040)                   // Mode switching 
	{ 
	  Opr_state &=~0x0040;                   // Clear this state
	  #if TK_MODE2 ==ON
	  TK_Modeswitch();	 
	  #endif
	}
  else if( Opr_state &0x4000)                // Data was full process it
	{          	
        
	   Update_origindata();
	   TK_Base_percounter++;                 // Every come every ++  

	   Update_upload_data();

	    if(Opr_state &0x0080)                // Mode 2 
		   {
		     #if TK_MODE2 ==ON
			  TK_Threshold_release_temp   =TK_Md2_Threshold_release;   // 0.4-0.9 ɿ趨0.530ɿҪ15  5==50%
			  TK_Samplevalue_step_temp    =TK_Md2_Samplevalue_step;    // 趨1--65535 ֮һ
			  TK_basevalue_step_temp      =TK_Md2_basevalue_step;      // ߲趨  1--65535 ȲҪС
			  TK_BaseSamples_perscan_temp =TK_Md2_BaseSamples_perscan;     // ߸ 趨1--65535
			  TK_Debounce_press_temp      =TK_Md2_Debounce_press;      // µĴ趨
			  TK_Debounce_release_temp    =TK_Md2_Debounce_release;    // 뿪Ĵ趨
			  p =Threshold_md2table;			
			  #endif
		   }
		   else                                                       // Mode 1  Default mode
		   {
			  TK_Threshold_release_temp   =TK_Threshold_release;      // 0.4-0.9 ɿ趨0.530ɿҪ15  5==50%
			  TK_Samplevalue_step_temp    =TK_Samplevalue_step;       // 趨1--65535 ֮һ
			  TK_basevalue_step_temp      =TK_basevalue_step;         // ߲趨  1--65535 ȲҪС
			  TK_BaseSamples_perscan_temp =TK_BaseSamples_perscan;    // ߸ 趨1--65535
			  TK_Debounce_press_temp      =TK_Debounce_press;         // µĴ趨
			  TK_Debounce_release_temp    =TK_Debounce_release;       // 뿪Ĵ趨
			  p =Threshold_table;
		   }

	#if TK_Powersavemode_function  ==ON

		    if((Powersave_switching ==2)&&(Opr_state &0x0020)&&(Opr_state &0x0080)&&(TK_modeth ==2))
		       { 
					uchar ii;					  	  
					for(ii=0;ii<ChannelSummd2;ii++)
					{
						TK_value_average[ii] =TK_value_origin[ii];
						TK_value_filter[ii]  =TK_value_origin[ii];
					}	   
				Powersave_switching =0;
			   }
	#endif

      for (i=0;i<Tkchnum;i++)
	  { 
			ulong pow_2 = pow_ulong(i);
		 // Origin data   Update value data	   
		 //Update_filterdata(i,TK_Samplevalue_step_temp);
		 TK_value_filter[i] = DataFilter(TK_value_origin[i],TK_value_filter[i]);	    
		if( TK_value_origin[i] >( TK_value_average[i] +p[i] ) )                      // 
		 {		   		                                                  
		   Lock_average =1;                                                          // This time not update average
		   #if TK_Powersavemode_function  ==ON
		        if((Opr_state &0x0020)&&(Opr_state &0x0080)&&(TK_modeth ==2))        // if Mode2 and Powersave flag wakeup to default mode
				{
 				 TK_modeth =1;                                                       // Wakeup Switch to default mode 
				 Customer_wakeupfromsleepmode_init();
				}
           #endif
		 }		
		 else 
		 {
		   Lock_average =0;
		   if(TK_press_table[i] &&(TK_press_table[i] < TK_Debounce_press_temp))                              // No key press  but at press conter state  (TK_state &((ulong)1<<i))==0
		   {
		    TK_Jitter_tolerance[i]++;
			if(TK_Jitter_tolerance[i] >Jitter_tolerance)
			{
			 TK_press_table[i] =0;                             // Clear press counter
			 TK_Jitter_tolerance[i] =0;
			}
		   }
		   else 
		   {
		    TK_Jitter_tolerance[i] =0;
		   }
		 }
		/********************************************** Check Trigger *****************************************/		
		   uchar Mucheck=1;
		if(Mult_inhibition( (TK_value_filter[i] - TK_value_average[i]), TK_Mult_inhibition))
		{
		  Mucheck =1;		
		}
		else    //Be inhibition
		{
			Mucheck =0;
			Lock_average =0;  // Go on average
		                    // Clear state
          if(TK_state &(pow_2)) 
		   {
			TK_release_table[i] =TK_Debounce_release_temp;
			TK_state &= ~pow_2;//~((ulong)1<<i);                    // Clear this trigger bit process	
			Customer_Keystatejustrelease();				   
			if(TK_timeout_counter[i]!=0){TK_timeout_counter[i]=0;}       // Close timer counter					  
			TK_D_value[i] = 0;                                      // Save the Dlt value
		   }
		 }
		 
		 
		 if((TK_value_filter[i] > (TK_value_average[i]+p[i])) && Mucheck )         // Check pressif( TK_value_origin[i] >( TK_value_average[i] +Threshold_table[i] ) )     // 
		   {
			   TK_press_table[i]++;
			   TK_release_table[i]=0;

		    //TK_press_counter++;
			//TK_release_counter=0;
			if(TK_press_table[i] >TK_Debounce_press_temp)                                   // Press check
			 {
				 if(TK_jitter_Value < Jitter_level2_Threshold)
				{
				  TK_press_table[i]=TK_Debounce_press_temp;
				  TK_state |=((ulong)1<<i);                                  // Set trigger process
				  Customer_Keystatejustpress();
				  if(TK_timeout_counter[i]==0){TK_timeout_counter[i]=1;}     // Start counter

				   #if TK_Powersavemode_function  ==ON                                   // Any press do wakeup
					if((Opr_state &0x0020)&&(Opr_state &0x0080)&&(TK_modeth ==2))        // if Mode2 and Powersave flag wakeup to default mode
					{
					 TK_modeth =1;                                                       // Wakeup Switch to default mode 
					 Customer_wakeupfromsleepmode_init();
					}
				   #endif

				  //#if  TK_Singlepress ==ON                                    // Save the Dlt value
				   TK_D_value[i]=TK_value_filter[i]-TK_value_average[i];      // Save the Dlt value
				  //#endif

				   if((Opr_state &0x0080)==0)     //Mode 1 
				   {
					  #if  TK_Matrix_Function ==ON  
					   if(TK_state & TK_Matrix_RID){ Opr_state|=0x0200; Lock_average =1; }
						else{Opr_state &=~0x0200;}
					   if(TK_state & TK_Matrix_CID){ Opr_state|=0x0100; Lock_average =1; }
						else{Opr_state &=~0x0100;}
					  #endif
					  #if TK_Slider_Function ==ON
					   if(TK_state & TK_slider_ID){ Opr_state|=0x0800; Lock_average =1; }
					   else{Opr_state &=~0x0800;}
					  #endif
					  #if TK_Wheel_Function ==ON
					   if(TK_state & TK_wheel_ID){ Opr_state|=0x0400; Lock_average =1; }
					   else{Opr_state &=~0x0400;}
					  #endif
				   }
				}
				else
				{
					TK_press_table[i] = 0;
				}
			  }
		   }
		   else
		   {
			   TK_press_table[i]=0;                             // Clear press counter
			  TK_Jitter_tolerance[i] =0;
			  if(TK_state &((ulong)1<<i))                        // Already press prepare to release check
			  {			     
				  if(TK_value_filter[i] <( TK_value_average[i] + ((p[i]*TK_Threshold_release_temp)/10) ) )
				  {				
			        TK_release_table[i]++;					
					if(TK_release_table[i] >TK_Debounce_release_temp)     // Release check
			          {
					   TK_release_table[i] =TK_Debounce_release_temp;
					   TK_state &=~((ulong)1<<i);                    // Clear this trigger bit process
					   Customer_Keystatejustrelease();
					   if(TK_timeout_counter[i]!=0){TK_timeout_counter[i]=0;}       // Close timer counter
					   #if  TK_Singlepress ==ON                                     // Clear Dlt value
                         TK_D_value[i]=0;                                         // Clear the Dlt value
                       #endif
			          }				    
				  }
				  else
				  {
				   TK_release_table[i]=0;                                           // Clear the release counter
				  }
			  }
			 else if((Lock_average==0)&&(TK_Base_percounter >TK_BaseSamples_perscan_temp))
			  {
				 //Check if the number i was the Slider or Wheel area and the Slider or Wheel was touched then do not update the average 			    
				  ulong SWid =((ulong)1<<i);
				 if(((TK_wheel_value!=0)&&(SWid &TK_wheel_ID))||((TK_slider_value!=0)&&(SWid &TK_slider_ID)))
				 {}
				 else
				 {			    
				  //Update_averagedata(i, TK_basevalue_step_temp );				 	                       
				  TK_value_average[i] = DataFilter(TK_value_filter[i],TK_value_average[i]);
				 }				 	                       
			  }
		   }
		/********************************************** Check Trigger *****************************************/
		 TK_value_origin[i] =0;                                     // Clear the origin data  
		 #if TK_Powersavemode_function  ==ON
		 if(TK_Sleep_Cnt > 100)
		 {
			 TK_Sleep_Cnt++;
			 if(TK_Sleep_Cnt > 110)
			 {
				 TK_Sleep_Cnt = 0;
				 TK_mode1_nopresstimer = TK_Mode0_nokeytoswitch_time+5;

				 uchar i;
				 for(i = 0;i<TK_NUM;i++)
				 {
				 TK_value_average[i] = DataFilter(TK_value_filter[i],TK_value_average[i]);
				 }
				 
			 }
		 }
		 #endif
	  }	 
	  TK_pressing_fuc();
	  if(TK_Base_percounter >(TK_BaseSamples_perscan_temp+3)){TK_Base_percounter =0;} // For next every  TK_BaseSamples_perscan_temp  sample update
	  Opr_state &=~0x4000;                             // Release this state
	  //Single key press check 
	  #if  TK_Singlepress ==ON      
	        if(TK_state)                                                          // Any key pressed
			{                                     
             Singlekeyprocess();                                                  // Get Single key press state
			}
			else
			{
			 TK_state_single=0;
			}
      #endif

	  if((Opr_state &0x0020)&&(Opr_state &0x0080)&&(TK_modeth ==2))             //At mode2 mode and powersave open
	  {
		 #if TK_Powersavemode_function  ==ON
	     //Sleep xxx ms and then scan 
		  Sleep_thenscan();
		  TK_Sleep_Cnt++;
		  if(TK_Sleep_Cnt > 100)
		  {
				TK_modeth =1;                                                       // Wakeup Switch to default mode 				 
				Customer_wakeupfromsleepmode_init();
		  }
         #endif		  
	  }
	  else // Mode 1/2 scan 
	  {
		  #if TK_Jittersample ==ON                                                   // Jitter setting
		  uint Time_now;
		  if(Timer_counter){Time_now =T8N+250;}else{Time_now =T8N;}
		  if( ((Opr_state &0x3000) ==0x3000)&&( Time_now>(TK_Jitter_timer +TK_Jitter_delay)) )        // Jitter scan 
		  {
		   PBT7 = 1;                                                     // When scan the PB7 must set input	 
			if(Opr_state &0x0080)                                        // Mode 2 
			{	 
			  Config_TKIO2(Channel_md2table[Tkscan_numth]);	     	                											       	  	 
			}
		   else
			{
			  Config_TKIO2(Channel_table[Tkscan_numth]);
			}
		  // Config_TKIO2(Channel_table[Tkscan_numth]);	     	                											       	  	 
		   TKCTL = 0x03;                 // ʹܴʹģ飬TKGO=1ɨ	
		   Opr_state &=~0x1000;          // into scan busy state
		  }
		  #endif
	  }
	  if((Opr_state &0x0080)==0)     //Mode 1 
     {
	  #if TK_Slider_Function ==ON	                                                    
       Slider_process();              // Slider function process
	   Customer_Slidervalue_justrefreshed();
	  #endif

	  #if TK_Wheel_Function ==ON	                                                    
       Wheel_process();              // Slider function process
	   Customer_Wheelvalue_justrefreshed();
	  #endif

	  #if  TK_Matrix_Function ==ON  
	  Matrix_process();
	  Customer_Matrixvalue_justrefreshed();
	  #endif
	 }
	  //TK_Modeswitch();
	  #if TK_Powersavemode_function  ==ON
	  if(TK_state){TK_mode1_nopresstimer =0;}       // Any key press clear the no key timer

      #endif
	  Customer_Tkdataready();
	}
  else if( Opr_state &0x8000)                       // Scan Enable
    {
	if((Opr_state &0x0020)&&(Opr_state &0x0080)&&(TK_modeth ==2)&&(Opr_state &0x1000))
	  { // Power save mode not use jitter sample
		// Scan not sleep 
		//Sleep_thenscan();
		PBT7 = 1;                      // When scan the PB7 must set input
		if(Opr_state &0x0080)          // Mode 2 
		{	 
			#if TK_MODE2 ==ON
			Config_TKIO2(Channel_md2table[Tkscan_numth]);	 
			#endif    	                											       	  	 
		}
		else
		{
			Config_TKIO2(Channel_table[Tkscan_numth]);
		}
		TKCTL = 0x03;                 // ʹܴʹģ飬TKGO=1ɨ	
		Opr_state &=~0x1000;          // into scan busy state		

	  }
	  else
	  {
		  #if TK_Jittersample ==ON
		  uint Time_now;
		  if(Timer_counter){Time_now =T8N+250;}else{Time_now =T8N;}

		  if( ((Opr_state &0x3000) ==0x3000)&&( Time_now>(TK_Jitter_timer+TK_Jitter_delay)) )         // Jitter scan and one bit complete
		  {
		   PBT7 = 1;                                                    // When scan the PB7 must set input
		   if(Opr_state &0x0080)                                        // Mode 2 
			{	 
			  Config_TKIO2(Channel_md2table[Tkscan_numth]);	     	                											       	  	 
			}
		   else
			{
			  Config_TKIO2(Channel_table[Tkscan_numth]);
			}
		   TKCTL = 0x03;                 //ʹܴʹģ飬TKGO=1ɨ	
		   Opr_state &=~0x1000;          //into scan busy state
		  }
		  #endif
	  }
    }			    
}



